echo "Please remember that the OUT16 and OUT32 directories must be compiled!"
echo "IF YOU HAVEN'T DONE SO, PLEASE READ THE readme.txt FILES IN THE OUT16 AND OUT32 DIRECTORIES!"
echo "*************************************************************************"
echo "M-OS Platinum/3 will be published to these directories: pub16\ AND pub32\"
pause
echo "Building directories"
md pub16 >nul
md pub16\EXAMPLES >nul
md pub16\FONTS >nul
md pub16\ICONS >nul
md pub16\ICONS\FILETYPE >nul
md pub16\INI >nul
md pub16\MODULES >nul
md pub16\MOUSE >nul
md pub16\SYSTEM >nul
md pub16\SYSTEM\BIGFOOT >nul
md pub16\SYSTEM\DLS >nul
md pub16\TEMP >nul
md pub16\TMP >nul
md pub16\SPEECH >nul
md pub16\XEPGUI >nul

md pub32 >nul
md pub32\EXAMPLES >nul
md pub32\FONTS >nul
md pub32\ICONS >nul
md pub32\ICONS\FILETYPE >nul
md pub32\INI >nul
md pub32\MODULES >nul
md pub32\MOUSE >nul
md pub32\SYSTEM >nul
md pub32\SYSTEM\BIGFOOT >nul
md pub32\SYSTEM\DLS >nul
md pub32\TEMP >nul
md pub32\TMP >nul
md pub32\SPEECH >nul
md pub32\XEPGUI >nul
echo "Copying System Executables"
echo "Copying 16-bit executables"
copy out16\*.exe pub16 >nul
echo "Copying 32-bit executables"
copy out32\*.exe pub32 >nul
echo "Copying default EXEs for 16-bit publish"
copy bench.exe pub16 >nul
copy bills2.exe pub16 >nul
copy bmp2bsv.exe pub16 >nul
copy browse1.exe pub16 >nul
copy browse.exe pub16 >nul
copy capture.exe pub16 >nul
copy deskbkgd.exe pub16 >nul
copy drives.exe pub16 >nul
copy edit.exe pub16 >nul
copy explorer.exe pub16 >nul
copy fileman.exe pub16 >nul
copy findfile.exe pub16 >nul
copy mosscr.exe pub16 >nul
copy multitsk.exe pub16 >nul
copy mystify.exe pub16 >nul
copy openavi.exe pub16 >nul
copy plugbrws.exe pub16 >nul
copy raycast.exe pub16 >nul
copy space2.exe pub16 >nul
copy ss*.exe pub16 >nul
copy syncir.exe pub16 >nul
copy unzip.exe pub16 >nul
copy writer.exe pub16 >nul

echo "Copying default EXEs for 32-bit publish"
copy bench.exe pub32 >nul
copy bills2.exe pub32 >nul
copy bmp2bsv.exe pub32 >nul
copy browse1.exe pub32 >nul
copy browse.exe pub32 >nul
copy capture.exe pub32 >nul
copy deskbkgd.exe pub32 >nul
copy drives.exe pub32 >nul
copy edit.exe pub32 >nul
copy explorer.exe pub32 >nul
copy fileman.exe pub32 >nul
copy findfile.exe pub32 >nul
copy mosscr.exe pub32 >nul
copy multitsk.exe pub32 >nul
copy mystify.exe pub32 >nul
copy openavi.exe pub32 >nul
copy plugbrws.exe pub32 >nul
copy raycast.exe pub32 >nul
copy space2.exe pub32 >nul
copy ss*.exe pub32 >nul
copy syncir.exe pub32 >nul
copy unzip.exe pub32 >nul
copy writer.exe pub32 >nul

echo "Copying MAIN system files for 16-bit publish"
copy main2\examples\*.* pub16\examples >nul
copy main2\fonts\*.* pub16\fonts >nul
copy main2\icons\*.* pub16\icons >nul
copy main2\icons\filetype\*.* pub16\icons\filetype >nul
copy main2\ini\*.* pub16\ini >nul
copy main2\modules\*.* pub16\modules >nul
copy main2\mouse\*.* pub16\mouse >nul
copy main2\system\*.* pub16\system >nul
copy main2\system\bigfoot\*.* pub16\system\bigfoot >nul
copy main2\system\dls\*.* pub16\system\dls >nul
copy main2\temp\*.* pub16\temp >nul
copy main2\tmp\*.* pub16\tmp >nul

echo "Copying MAIN system files for 32-bit publish"
copy main2\examples\*.* pub32\examples >nul
copy main2\fonts\*.* pub32\fonts >nul
copy main2\icons\*.* pub32\icons >nul
copy main2\icons\filetype\*.* pub32\icons\filetype >nul
copy main2\ini\*.* pub32\ini >nul
copy main2\modules\*.* pub32\modules >nul
copy main2\mouse\*.* pub32\mouse >nul
copy main2\system\*.* pub32\system >nul
copy main2\system\bigfoot\*.* pub32\system\bigfoot >nul
copy main2\system\dls\*.* pub32\system\dls >nul
copy main2\temp\*.* pub32\temp >nul
copy main2\tmp\*.* pub32\tmp >nul

echo "Copying miscellaneous files for 16-bit publish"
copy misc\*.* pub16 >nul
copy misc\xepgui\*.* pub16\xepgui >nul

echo "Copying miscellaneous files for 32-bit publish"
copy misc\*.* pub32 >nul
copy misc\xepgui\*.* pub32\xepgui >nul

echo "Copying RushOS programs for 16-bit publish"
copy rush\*.* pub16 >nul

echo "Copying RushOS programs for 32-bit publish"
copy rush\*.* pub32 >nul

echo "Copying Speech Engine for 16-bit publish"
copy speech\*.* pub16\speech >nul

echo "Copying Speech Engine for 32-bit publish"
copy speech\*.* pub32\speech >nul

echo "Copying Text files for 16-bit and 32-bit publishes"
copy txtfiles\*.* pub16 >nul
copy txtfiles\*.* pub32 >nul

echo "Finalizing..."
del pub32\readme.txt >nul
del pub16\readme.txt >nul
rename pub16\welcome.txt readme.txt >nul
rename pub32\welcome.txt readme.txt >nul
copy matrix*.bsv pub16 >nul
copy matrix*.bsv pub32 >nul
copy *.cfg pub16 >nul
copy *.cfg pub32 >nul
copy drives.ini pub16 >nul
copy drives.ini pub32 >nul
copy *.cur pub16 >nul
copy *.cur pub32 >nul
copy *.dat pub16 >nul
copy *.dat pub32 >nul
copy *.dci pub16 >nul
copy *.dci pub32 >nul
copy *.exp pub16 >nul
copy *.exp pub32 >nul

copy CONFIRM pub16 >nul
copy DSKLITE pub16 >nul
copy ENTER pub16 >nul
copy EXIT pub16 >nul
copy HOMEDESK pub16 >nul
copy SAFEDESK pub16 >nul

copy CONFIRM pub32 >nul
copy DSKLITE pub32 >nul
copy ENTER pub32 >nul
copy EXIT pub32 >nul
copy HOMEDESK pub32 >nul
copy SAFEDESK pub32 >nul

copy *.fnt pub16 >nul
copy *.fnt pub32 >nul

copy *.lst pub16 >nul
copy *.lst pub32 >nul

copy *.bdb pub16 >nul
copy *.bdb pub32 >nul
copy *.com pub16 >nul
copy *.com pub32 >nul
copy *.bat pub16 >nul
copy *.bat pub32 >nul
del pub16\publish.bat >nul
del pub32\publish.bat >nul
copy *.pic pub16 >nul
copy *.pic pub32 >nul

copy DATABASE.PNP pub16 >nul
copy DATABASE.PNP pub32 >nul
copy CUSTOM.RDI pub16 >nul
copy CUSTOM.RDI pub32 >nul
copy SYSTEM.RTI pub16 >nul
copy SYSTEM.RTI pub32 >nul
copy *.INF pub16 >nul
copy *.INF pub32 >nul
copy PLUGBRWS.TEM pub16 >nul
copy PLUGBRWS.TEM pub32 >nul
copy *.THM pub16 >nul
copy *.THM pub32 >nul
copy *.TMP pub16 >nul
copy *.TMP pub32 >nul

echo "***************************************"
echo "Done."
echo "You may deal with the published folders as you wish."
echo "Here are the published copies of M-OS Platinum/3:"
echo "       - PUB16 (the 16-bit publish)"
echo "       - PUB32 (the 32-bit publish)"
echo "Enjoy."