' Data Components Confidential
' (C) Data Components Software Development 2004-2005
'
' CUBET1.BAS => CUBET1.EXE
' This program displays a 3d representation of
' a pyramid within the M-OS environment. The
' pyramid can be rotated using arrow keys.
'
' Originally coded by Silizium-Net
'
' THIS PROGRAM IS COMPILED WITH THE "MOSDLL"

'Downloaded von www.silizium.de.vu
DECLARE SUB box (bcol%, x%, y%, x2%, y2%, title$, tc%, tbg%, tsh%, shwmen%, clse%, minm%)
SCREEN 12
DEFSNG A-Z

CONST positive = .1
CONST negative = -.1
box 0, 0, 0, 640, 480, "3D Engine in Millennium OS", 15, 1, 0, 0, 1, 1
WINDOW (-160, -100)-(159, 99)

stretch = 150
distance = 500
velocity = positive

    x(0) = 0: x(1) = 25: x(2) = -25: x(3) = -25: x(4) = 25
    y(0) = -17: y(1) = 17: y(2) = 17: y(3) = 17: y(4) = 17
    z(0) = 0: z(1) = 25: z(2) = 25: z(3) = -25: z(4) = -25

GOSUB Initialize
GOSUB DrawPoly

DO
    a$ = INKEY$
    SELECT CASE a$
        CASE "p"
            a$ = INPUT$(1)
        CASE CHR$(0) + CHR$(75)
            velocity = positive
                FOR a = 0 TO 4
                    nx(a) = z(a) * SIN(velocity) + x(a) * COS(velocity)
                    nz(a) = z(a) * COS(velocity) - x(a) * SIN(velocity)
                NEXT a
                GOSUB Switch
                GOSUB DrawPoly
        CASE CHR$(0) + CHR$(77)
            velocity = negative
                FOR a = 0 TO 4
                    nx(a) = z(a) * SIN(velocity) + x(a) * COS(velocity)
                    nz(a) = z(a) * COS(velocity) - x(a) * SIN(velocity)
                NEXT a
                GOSUB Switch
                GOSUB DrawPoly
        CASE CHR$(0) + CHR$(72)
            velocity = positive
                FOR a = 0 TO 4
                  ny(a) = y(a) * COS(velocity) - z(a) * SIN(velocity)
                  nz(a) = y(a) * SIN(velocity) + z(a) * COS(velocity)
                NEXT a
                GOSUB Switch
                GOSUB DrawPoly
        CASE CHR$(0) + CHR$(80)
            velocity = negative
                FOR a = 0 TO 4
                  ny(a) = y(a) * COS(velocity) - z(a) * SIN(velocity)
                  nz(a) = y(a) * SIN(velocity) + z(a) * COS(velocity)
                NEXT a
                GOSUB Switch
                GOSUB DrawPoly
        CASE CHR$(0) + CHR$(81)
            velocity = positive
                FOR a = 0 TO 4
                  nx(a) = x(a) * COS(velocity) - y(a) * SIN(velocity)
                  ny(a) = y(a) * COS(velocity) + x(a) * SIN(velocity)
                NEXT a
                GOSUB Switch
                GOSUB DrawPoly
        CASE CHR$(0) + CHR$(79)
            velocity = negative
                FOR a = 0 TO 4
                  nx(a) = x(a) * COS(velocity) - y(a) * SIN(velocity)
                  ny(a) = y(a) * COS(velocity) + x(a) * SIN(velocity)
                NEXT a
                GOSUB Switch
                GOSUB DrawPoly
        CASE "="
            stretch = stretch - 15
            GOSUB Switch
            GOSUB DrawPoly
        CASE "-"
            stretch = stretch + 15
            GOSUB Switch
            GOSUB DrawPoly
        CASE "z"
            x(0) = x(0) + 5
            x(1) = x(1) + 5
            x(2) = x(2) + 5
            x(3) = x(3) + 5
            x(4) = x(4) + 5
            GOSUB Initialize
            GOSUB Switch
            GOSUB DrawPoly
        CASE "x"
            x(0) = x(0) - 5
            x(1) = x(1) - 5
            x(2) = x(2) - 5
            x(3) = x(3) - 5
            x(4) = x(4) - 5
            GOSUB Initialize
            GOSUB Switch
            GOSUB DrawPoly
        CASE "a"
            y(0) = y(0) - 5
            y(1) = y(1) - 5
            y(2) = y(2) - 5
            y(3) = y(3) - 5
            y(4) = y(4) - 5
            GOSUB Initialize
            GOSUB Switch
            GOSUB DrawPoly
        CASE "s"
            y(0) = y(0) + 5
            y(1) = y(1) + 5
            y(2) = y(2) + 5
            y(3) = y(3) + 5
            y(4) = y(4) + 5
            GOSUB Initialize
            GOSUB Switch
            GOSUB DrawPoly
    END SELECT

LOOP UNTIL a$ = CHR$(27)

END

Initialize:
    FOR a = 0 TO 4
        nx(a) = x(a)
        ny(a) = y(a)
        nz(a) = z(a)
    NEXT a
RETURN

Switch:
    FOR a = 0 TO 4
      x(a) = nx(a)
      y(a) = ny(a)
      z(a) = nz(a)
    NEXT a
    
RETURN

DrawPoly:

    FOR a = 0 TO 4
      ox(a) = sx(a)
      oy(a) = sy(a)
    NEXT a
      
    FOR a = 0 TO 4
      sx(a) = distance * (nx(a) / (nz(a) - stretch))
      sy(a) = distance * (ny(a) / (nz(a) - stretch))
    NEXT a

    WAIT &H3DA, 8
      
    LINE (ox(0), oy(0))-(ox(1), oy(1)), 0
    LINE (ox(1), oy(1))-(ox(2), oy(2)), 0
    LINE (ox(2), oy(2))-(ox(3), oy(3)), 0
    LINE (ox(3), oy(3))-(ox(4), oy(4)), 0
    LINE (ox(4), oy(4))-(ox(1), oy(1)), 0
      
    LINE (ox(1), oy(1))-(ox(0), oy(0)), 0
    LINE (ox(2), oy(2))-(ox(0), oy(0)), 0
    LINE (ox(3), oy(3))-(ox(0), oy(0)), 0
    LINE (ox(4), oy(4))-(ox(0), oy(0)), 0

    LINE (sx(0), sy(0))-(sx(1), sy(1)), 15
    LINE (sx(1), sy(1))-(sx(2), sy(2)), 15
    LINE (sx(2), sy(2))-(sx(3), sy(3)), 15
    LINE (sx(3), sy(3))-(sx(4), sy(4)), 15
    LINE (sx(4), sy(4))-(sx(1), sy(1)), 15
      
    LINE (sx(1), sy(1))-(sx(0), sy(0)), 15
    LINE (sx(2), sy(2))-(sx(0), sy(0)), 15
    LINE (sx(3), sy(3))-(sx(0), sy(0)), 15
    LINE (sx(4), sy(4))-(sx(0), sy(0)), 15

RETURN

