' Data Components Confidential
' (C) Data Components Software Development 2004-2005
'
' GDI.BAS => GDI.EXE
' This program contains the external commands
' which M-OS uses in its desktop environment.
'
' THIS PROGRAM IS COMPILED WITH THE "MOSDLL"

DECLARE SUB Place.Icons (startx%, starty%, FileName$)
DECLARE SUB Place.Iconz (x%, y%, FileName$)
DECLARE SUB BIGFOOT (FootX%, FootY%, FootOpen%)
DECLARE SUB Script (ScriptName$)
DECLARE SUB Display (Prefix$)
DEFINT A-Z
'$DYNAMIC

DECLARE SUB GUItask.Manager (Instruction%, Optin%)
DECLARE SUB RefreshClock ()
DECLARE SUB DrawDesktop ()
DECLARE SUB redraw ()
DECLARE SUB ibox (x%, y%, chrs%, MaxChar%)
DECLARE SUB Xorline (x%, y%, x2%, y2%, boxa%, Pixels%)
DECLARE SUB MouseDriver (ax%, bx%, cx%, dx%)
DECLARE FUNCTION MouseLimit% (MiniX%, MiniY%, MaxiX%, MaxiY%)
DECLARE FUNCTION MouseInOut% (Left%, Up%, text1$, InOut%)
DECLARE SUB MouseStatus (Lb%, Rb%, xMouse%, yMouse%)
DECLARE SUB MouseShow ()
DECLARE SUB w (a$, x%, y%, Co%, Bkgd%, Shadow%)
DECLARE SUB Place.Icon (x%, y%, FileName$)
DECLARE SUB button2 (x1%, y1%, InOut%, txt$, mc%)
DECLARE SUB Box (bcol%, x%, y%, x2%, y2%, title$, tc%, tbg%, tsh%, shwmen%, clse%, minm%)
DECLARE SUB mousehide ()
DECLARE SUB EraseStart ()

TYPE RegType
		 ax    AS INTEGER
		 bx    AS INTEGER
		 cx    AS INTEGER
		 dx    AS INTEGER
		 bp    AS INTEGER
		 si    AS INTEGER
		 di    AS INTEGER
		 flags AS INTEGER
END TYPE
'
' Define the type needed for INTERUPTX
'
TYPE RegTypeX
		 ax    AS INTEGER
		 bx    AS INTEGER
		 cx    AS INTEGER
		 dx    AS INTEGER
		 bp    AS INTEGER
		 si    AS INTEGER
		 di    AS INTEGER
		 flags AS INTEGER
		 ds    AS INTEGER
		 es    AS INTEGER
END TYPE


'DECLARE SUB ABSOLUTE (address AS INTEGER)
DECLARE SUB INTERRUPT (intnum AS INTEGER, inreg AS RegType, outreg AS RegType)
DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS RegTypeX, outreg AS RegTypeX)
DIM Regs AS RegType          ' Interrupt needed for Regular Mouse Routines,


DIM SHARED Button.Button(650)
DIM SHARED GetBehind(120, 120)
DIM SHARED mouse$
DIM SHARED BehindForm(100, 100) AS INTEGER
DIM SHARED text1$
DIM SHARED FootX%, FootY%, FootOpen%
DIM SHARED ExplorFile$, DefaultExplorFile$
DIM SHARED path$

mouse$ = SPACE$(57)
FOR I% = 1 TO 57
		READ a$
		H$ = CHR$(VAL("&H" + a$))
		MID$(mouse$, I%, 1) = H$
NEXT I%
OPEN "PATH.DAT" FOR INPUT AS #1
INPUT #1, path$
CLOSE #1
CLOSE #3
OPEN path$ + "\TMP\GDINFO.TMP" FOR INPUT AS #3
INPUT #3, FootX%, FootY%, FootOpen%
INPUT #3, ExplorFile$, DefaultExplorFile$
CLOSE #3

SCREEN 12
IF COMMAND$ = "&REFRESH_DESKTOP" THEN
	 redraw
	 SYSTEM
END IF
'redraw

MouseShow
'Script "&FIND_MODULE1"
Script COMMAND$

NormalMouse:
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

HourGlass1:
DATA &HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF
DATA &HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF
DATA &HFFFF,&H2004,&H2004,&H2004,&H1008,&H990,&H420,&H240
DATA &H240,&H420,&H810,&H1008,&H2084,&H2144,&H22A4,&HFFFF
DATA 5 ,0

REM $STATIC
DEFSNG A-Z
SUB Capture (Prefix$)
DEF SEG = &HA000
OUT &H3CE, 4 'tells the vga control what function we are going
'to use (in this case 4, change plane to read from)
FOR Plane = 0 TO 3
OUT &H3CF, Plane 'switches planes
BSAVE Prefix$ + LTRIM$(STR$(Plane)) + ".BSV", 0, 38400
NEXT Plane
END SUB

SUB ChangeCursor (a$)
	DIM Regs AS RegType          ' Use for QB45 Near Strings
	REM DIM Regs as RegTypeX     ' Use for QBX/VBDOS Far Strings

	' Assigns Custom Cursor Shape Depending on String Passed.
	' Use RegType in QB; need ES Register for PDS/VBDOS Far String support.

	SELECT CASE a$
	CASE "C"
		 RESTORE HourGlass1:
	CASE ELSE
		 EXIT SUB
	END SELECT

	'====================================================================
	' Below is the part you're most interested in. I read it in as a
	' String * 1 (BYTE) .. 16 Bytes for the Cursor Mask, 16 Bytes for
	' the Screen Mask, and the last two Integers the location of the Cursor
	' Hot Spot - the Point actually referenced in Mouse Coordinates.

	' Read in Graphical Mouse Cursor Data
	FOR I% = 1 TO 32
		READ Wrd%
		MMsk$ = MMsk$ + MKI$(Wrd%)         ' Cursor Graphical Data
	NEXT I%
	READ Hotx, Hoty                      ' Cursor HotSpot

	' Now For the Interrupt call ..
	' Use Function 9 from Int 33 ..
	Regs.ax = 9: Regs.bx = Hotx: Regs.cx = Hoty
	Regs.dx = SADD(MMsk$)   ' Use with ALL Basics ..

	' Next Line not needed for QB, (Optional for PDS ??), needed for VBDOS
	' But using it stores Data as a Far String.
	REM Regs.es = SSEG(MMsk$)  ' Need InterruptX for this One ..

	INTERRUPT &H33, Regs, Regs        ' Call QB45 Near string Interrupt
	REM INTERRUPTX &H33, Regs,Regs    ' Call VBDOS/PDS Far String Interrupt
END SUB

SUB Display (Prefix$)
DEF SEG = &HA000

OUT &H3C4, 2 'tells the vga control what function we are going
'to use (in this case 2, select what plane(s) to write to)
FOR Plane = 0 TO 3
OUT &H3C5, 2 ^ Plane 'switches planes
BLOAD Prefix$ + LTRIM$(STR$(Plane)) + ".BSV", 0
NEXT Plane
END SUB

DEFINT A-Z
SUB DrawDesktop
CALL mousehide
Tcolor = 15
CLOSE #1
OPEN ExplorFile$ FOR INPUT AS #1
DO UNTIL EOF(1)
		INPUT #1, IcnX%, IcnY%, Icon$, IcnName$, action$, grp%
		IF Icon$ = "[MOS-GUI]" THEN
			TitleOfWindow$ = IcnName$
			EXIT DO
		END IF
LOOP
CLOSE #1
IF UCASE$(ExplorFile$) <> UCASE$(DefaultExplorFile$) THEN
		CLOSE #3
		OPEN path$ + "\TMP\GDINFO.TMP" FOR OUTPUT AS #3
		WRITE #3, FootX%, FootY%, FootOpen%
		WRITE #3, ExplorFile$, DefaultExplorFile$
		CLOSE #3
		Box 15, 0, 0, 640, 453, TitleOfWindow$ + " - Millennium OS Explorer", 15, 0, 0, 0, 1, 1
		Tcolor = 0
END IF
IF EnableDelete% = 1 THEN
		LINE (0, 1)-(660, 30), 4, BF
		LINE (0, 30)-(660, 32), 0, BF
		w "To Remove an Icon, click on it. To cancel, press ESC on your keyboard.", 30, 10, 15, 0, 0
END IF

OPEN ExplorFile$ FOR INPUT AS #1
DO UNTIL EOF(1)
INPUT #1, IcnX%, IcnY%, Icon$, IcnName$, action$, grp%

IF Icon$ = "[MOS-GUI]" THEN
	TitleOfWindow$ = IcnName$
	GOTO skipdesk
END IF
OPEN "SYSTEM\desktop.ini" FOR INPUT AS #98
INPUT #98, did$, ColorOfBG%, bkg$
CLOSE #98

Place.Icon IcnX%, IcnY%, path$ + "\ICONS\" + Icon$ + ".RTI"
LINE (IcnX% - ((LEN(IcnName$) / 2) * 8) + 13, IcnY% + 43)-(IcnX% - ((LEN(IcnName$) / 2) * 8) + 15 + (LEN(IcnName$) * 8) + 2, IcnY% + 55), ColorOfBG%, BF
w IcnName$, IcnX% - ((LEN(IcnName$) / 2) * 8) + 15, IcnY% + 45, 15, 0, 0
skipdesk:
LOOP
CLOSE #1
CALL MouseShow

END SUB

SUB EraseStart
'mousehide
'PUT (0, 429 - items% / .04), GetBehind, PSET
'Place.Icon 1, 455, "system\GF1__.___"
redraw
MouseShow
END SUB

SUB GUItask.Manager (Instruction%, Optin%)
IF Instruction% = 1 THEN
		t1act = 0
		t2act = 0
		t3act = 0
		Taskbar1 = 60
		TaskBar2 = 60 + 155
		TaskBar3 = 60 + 310
		'This Will Display the Minimised Applications
		yMulti% = 60
		CLOSE #6
			 OPEN "MULTI.TSK" FOR INPUT AS #6
		DO
			 INPUT #6, ObjectName$, Execute$
		IF ObjectName$ = "[TASK MANAGEMENT FILE]" THEN GOTO SkipOneItem
		IF t1act = 1 AND t2act = 1 THEN t3act = 1
		IF t1act = 1 AND t2act = 0 THEN t2act = 1
		IF t1act = 0 THEN t1act = 1
		LINE (yMulti%, 457)-(yMulti% + 150, 477), 15, B
		LINE (yMulti% + 1, 477)-(yMulti% + 150, 477), 8, B
		LINE (yMulti%, 478)-(yMulti% + 151, 478), 0, B
		LINE (yMulti% + 150, 457)-(yMulti% + 150, 476), 8, B
		LINE (yMulti% + 151, 457)-(yMulti% + 151, 477), 0, B
		w ObjectName$, yMulti% + 10, 464, 0, 0, 0
		yMulti% = yMulti% + 155
SkipOneItem:
		IF yMulti% > 520 THEN EXIT DO
		LOOP UNTIL EOF(6)
		CLOSE #6
ELSEIF Instruction% = 2 THEN
	 'Push button in
	 yMulti% = Optin%
	 LINE (yMulti%, 457)-(yMulti% + 150, 477), 0, B
	 LINE (yMulti% + 1, 477)-(yMulti% + 150, 477), 7, B
	 LINE (yMulti%, 478)-(yMulti% + 151, 478), 15, B
	 LINE (yMulti% + 150, 457)-(yMulti% + 150, 476), 7, B
	 LINE (yMulti% + 151, 457)-(yMulti% + 151, 477), 15, B
ELSEIF Instruction% = 3 THEN
		yMulti% = 0
		CLOSE #6
			 OPEN "MULTI.TSK" FOR INPUT AS #6
		DO
			 INPUT #6, ObjectName$, Execute$
	 
		IF Optin% = 1 THEN
			 IF Taskbar1 = yMulti% - 95 THEN
		'CommandAndFileRegistry Execute$
		EXIT DO
			 END IF
		END IF
		IF Optin% = 2 THEN
			 IF TaskBar2 = yMulti% - 95 THEN
		'CommandAndFileRegistry Execute$
		EXIT DO
			 END IF
		END IF
		IF Optin% = 3 THEN
			 IF TaskBar3 = yMulti% - 95 THEN
		'CommandAndFileRegistry Execute$
		EXIT DO
			 END IF
		END IF
	
		yMulti% = yMulti% + 155
		LOOP UNTIL EOF(6)

END IF

END SUB

SUB ibox (x, y, chrs, MaxChar)

IF chrs = MaxChar THEN chrs = chrs + 2
'/* Draw the input box */'
LINE (x + 1, y + 1)-(x + (chrs * 8) - 1, y + 11), 15, BF
LINE (x, y)-(x + (chrs * 8), y + 12), 8, B
LINE (x + 1, y + 12)-(x + (chrs * 8) - 1, y + 12), 15
LINE (x + (chrs * 8), y + 1)-(x + (chrs * 8), y + 12), 15
IF Tchrs$ = "***" THEN EXIT SUB

text1$ = ""
w "_", x + 3, y + 3, 0, 0, 0
DO
		DO
	KeyPressed$ = INKEY$
		LOOP WHILE KeyPressed$ = ""
		IF KeyPressed$ = CHR$(8) AND text1$ <> "" THEN
	text1$ = LEFT$(text1$, LEN(text1$) - 1)
	'CALL mousehide
	IF password% = -1 THEN
			LINE (x + 1, y + 1)-(x + (chrs * 8) - 2, y + 10), 15, BF
			w STRING$(LEN(text1$), "*") + "_", x + 3, y + 3, 0, 0, 0
	ELSE
			LINE (x + 1, y + 1)-(x + (chrs * 8) - 2, y + 10), 15, BF
			w text1$ + "_", x + 3, y + 3, 0, 0, 0
	END IF
	'CALL mouseshow
		END IF

		IF KeyPressed$ = CHR$(13) THEN EXIT DO
	 
		IF KeyPressed$ > CHR$(29) AND KeyPressed$ < CHR$(127) AND LEN(text1$) <> MaxChar THEN
	text1$ = text1$ + KeyPressed$
	'CALL mousehide
	IF password% = -1 THEN
			LINE (x + 1, y + 1)-(x + (chrs * 8) - 2, y + 10), 15, BF
			w STRING$(LEN(text1$), "*") + "_", x + 3, y + 3, 0, 0, 0
	ELSE
			LINE (x + 1, y + 1)-(x + (chrs * 8) - 2, y + 10), 15, BF
			w text1$ + "_", x + 3, y + 3, 0, 0, 0
	END IF
	'CALL mouseshow
		END IF

		IF LEN(text1$) = MaxChar THEN
	SOUND 2000, .5
		END IF
LOOP
IF password% = -1 THEN
		LINE (x + 1, y + 1)-(x + (chrs * 8) - 2, y + 10), 15, BF
		w STRING$(LEN(text1$), "*"), x + 3, y + 3, 0, 0, 0
ELSE
		LINE (x + 1, y + 1)-(x + (chrs * 8) - 2, y + 10), 15, BF
		w text1$, x + 3, y + 3, 0, 0, 0
END IF

Tchrs$ = text1$

END SUB

SUB MouseDriver (ax%, bx%, cx%, dx%)

	DEF SEG = VARSEG(mouse$)
	mouse% = SADD(mouse$)
	CALL ABSOLUTE(ax%, bx%, cx%, dx%, mouse%)

END SUB

SUB mousehide
 ax% = 2
 MouseDriver ax%, 0, 0, 0
END SUB

'/* This function handles the mouse when it is clicking a button           */'
FUNCTION MouseInOut (Left, Up, text1$, InOut)

MouseInOut = 0
Right = LEN(text1$) * 8 + 52: Down = 23

CALL button2(Left, Up, 1, text1$, 0)
DO
		CALL MouseStatus(LeftButton, RightButton, xMouse, yMouse)
		IF InOut = 1 THEN
	IF MouseLimit(Left, Up, Right, Down) = 0 THEN
			CALL mousehide
			CALL button2(Left, Up, 0, text1$, 0)
			CALL MouseShow
			MouseInOut = 2: EXIT FUNCTION
	END IF
		END IF
LOOP UNTIL LeftButton = 0
CALL button2(Left, Up, 0, text1$, 0)

END FUNCTION

'/* This function checks if the mouse is located in a given area           */'
FUNCTION MouseLimit (MiniX, MiniY, MaxiX, MaxiY)

MouseLimit = 0
CALL MouseStatus(LeftButton, RightButton, xMouse, yMouse)

IF xMouse >= MiniX AND xMouse <= MiniX + MaxiX THEN
		IF yMouse >= MiniY AND yMouse <= MiniY + MaxiY THEN
	MouseLimit = -1
		END IF
END IF

END FUNCTION

'DEFLNG A-Z
SUB MouseShow
	ax% = 1
	MouseDriver ax%, 0, 0, 0
END SUB

'DEFLNG A-Z
SUB MouseStatus (Lb%, Rb%, xMouse%, yMouse%)
	ax% = 3
	MouseDriver ax%, bx%, cx%, dx%
	Lb% = ((bx% AND 1) <> 0)
	Rb% = ((bx% AND 2) <> 0)
	xMouse% = cx%
	yMouse% = dx%
END SUB

DEFSNG A-Z
SUB redraw
mousehide
CLOSE #1
OPEN "SYSTEM\desktop.ini" FOR INPUT AS #1
INPUT #1, did$, ColorOfBG%, bkg$
CLOSE #1

'PAINT (1, 1), ColorOfBG%
'
IF UCASE$(bkg$) <> "(NONE)" THEN
IF ExplorFile$ = DefaultExplorFile$ THEN
'PRINT bkg$
'SLEEP
Display bkg$
END IF

ELSE

IF ExplorFile$ = DefaultExplorFile$ THEN
LINE (0, 0)-(640, 480), ColorOfBG%, BF
END IF

END IF
Place.Iconz 1, 455, path$ + "\system\GF1__.___"
LINE (55, 454)-(640, 480), 7, BF
LINE (0, 454)-(640, 480), 15, B
LINE (550, 457)-(550, 477), 8
LINE (550, 457)-(637, 457), 8
LINE (637, 457)-(637, 477), 15
LINE (550, 477)-(637, 477), 15
Place.Iconz 555, 458, path$ + "\system\GF7__.___"
OldTime$ = "0"
RefreshClock
DrawDesktop
GUItask.Manager 1, 0
END SUB

DEFINT A-Z
SUB RefreshClock

IF OldTime$ <> LEFT$(TIME$, 5) THEN
	 LINE (580, 460)-(630, 470), 7, BF
	 w LEFT$(TIME$, 5), 587, 464, 0, 0, 0
	 OldTime$ = LEFT$(TIME$, 5)
END IF

END SUB

SUB Script (ScriptName$)
MouseShow
IF ScriptName$ = "&RUN_FILE" THEN
	EraseStart
	mousehide
		RunX% = 3: RunY% = 320
redrawrun:
		GET (RunX%, RunY%)-(RunX% + 350, RunY% + 120), GetBehind
		Box 7, RunX%, RunY%, RunX% + 350, RunY% + 120, "Run", 15, 0, 0, 1, 1, 0
		button2 RunX% + 10, RunY% + 90, 0, "OK", 0
		button2 RunX% + 90, RunY% + 90, 0, "Cancel", 0
		button2 RunX% + 200, RunY% + 90, 0, "Browse", 0
		Place.Iconz RunX% + 10, RunY% + 20, path$ + "\system\GF5__.___"

		w "Type the filename of the file", RunX% + 30, RunY% + 30, 0, 0, 0
		w "program, or module and M-OS", RunX% + 30, RunY% + 40, 0, 0, 0
		w "will open it for you.", RunX% + 30, RunY% + 50, 0, 0, 0
		w "Open:", RunX% + 10, RunY% + 65, 0, 0, 0

		x = RunX% + 50: y = RunY% + 62: chrs = 28
		LINE (x + 1, y + 1)-(x + (chrs * 8) - 1, y + 11), 15, BF
		LINE (x, y)-(x + (chrs * 8), y + 12), 8, B
		LINE (x + 1, y + 12)-(x + (chrs * 8) - 1, y + 12), 15
		LINE (x + (chrs * 8), y + 1)-(x + (chrs * 8), y + 12), 15
		MouseShow

		DO
			MouseStatus Lb%, Rb%, cx%, dx%

		IF Lb% = -1 THEN
			 IF MouseLimit(RunX% + 10, RunY% + 90, 70, 23) = -1 THEN
		mousehide
		runz = MouseInOut(RunX% + 10, RunY% + 90, "OK", 1)
		PUT (RunX%, RunY%), GetBehind, PSET
		'CommandAndFileRegistry runcommand$
		OPEN path$ + "\TMP\START.TMP" FOR OUTPUT AS #4
		IF runcommand$ <> "" THEN
			PRINT #4, runcommand$
		ELSE
			PRINT #4, "cancel"
		END IF
		CLOSE
		MouseDriver 0, 0, 0, 0
		MouseShow
		EXIT SUB
			 END IF
			 IF MouseLimit(RunX% + 90, RunY% + 90, 95, 23) = -1 THEN
		mousehide
		runz = MouseInOut(RunX% + 90, RunY% + 90, "Cancel", 1)
		PUT (RunX%, RunY%), GetBehind, PSET
		MouseShow
			CLOSE
			OPEN path$ + "\TMP\START.TMP" FOR OUTPUT AS #4
				PRINT #4, "cancel"
			CLOSE
			EXIT SUB
		END IF
			 IF MouseLimit(RunX% + 200, RunY% + 90, 95, 23) = -1 THEN
		mousehide
		runz = MouseInOut(RunX% + 200, RunY% + 90, "Browse", 1)
		MouseShow
			END IF
		IF MouseLimit(RunX%, RunY%, 350, 15) THEN
			 IF MouseLimit(RunX% + 353 - 19, RunY% + 3, 17, 17) = -1 THEN
		mousehide
		Place.Icon RunX% + 350 - 19, RunY% + 4, path$ + "\system\close2.rti"
		DO
		 MouseStatus Lb%, Rb%, cx%, dx%
		LOOP WHILE Lb% = -1
		Place.Icon RunX% + 350 - 16, RunY% + 3, path$ + "\system\close1.rti"
		PUT (RunX%, RunY%), GetBehind, PSET
		MouseShow
	 EXIT SUB
			ELSE
		 mousehide
		 PUT (RunX%, RunY%), GetBehind, PSET
		 MouseShow
			 MouseStatus Lb%, Rb%, cx%, dx%
			DO
		MouseStatus Lb%, Rb%, cx%, dx%
		IF cx% > 270 THEN cx% = 270
		IF dx% > 320 THEN dx% = 320
		'LOCATE 1, 1: PRINT cx%, dx%
		oldcx% = cx%: olddx% = dx%
		mousehide
		GET (oldcx%, olddx%)-(oldcx% + 360, olddx% + 120), GetBehind
		MouseShow
		LINE (cx%, dx%)-(cx% + 350, dx% + 120), 15, B
		DO
			 MouseStatus Lb%, Rb%, cx%, dx%
			 IF cx% > 270 THEN cx% = 270
			 IF dx% > 320 THEN dx% = 320
		LOOP WHILE oldcx% = cx% AND olddx% = dx% AND Lb% = -1
			 mousehide
			 PUT (oldcx%, olddx%), GetBehind, PSET
			 MouseShow
			LOOP WHILE Lb% = -1
			RunX% = cx%: RunY% = dx%
			mousehide
			GOTO redrawrun
			END IF
		END IF


			IF MouseLimit(x, y, 28 * 8, 15) = -1 THEN
			 mousehide
			 ibox x, y, 28, 27
			 runcommand$ = text1$
			 MouseShow
			END IF
		END IF
		LOOP UNTIL INKEY$ = CHR$(27)
ELSEIF ScriptName$ = "&MEM_METER" THEN
		mousehide
		memX% = 100
		memY% = 100
redrawmem:
		GET (memX%, memY%)-(memX% + 260, memY% + 200), GetBehind
		Box 7, memX%, memY%, memX% + 260, memY% + 200, "Memory Meter", 15, 0, 0, 0, 1, 0
		w "Total Memory available to M-OS", memX% + 10, memY% + 20, 0, 0, 0
		LINE (memX% + 40, memY% + 40)-(memX% + 140, memY% + 180), 0, B
		LINE (memX% + 41, memY% + 179 - FRE(1) / 430)-(memX% + 139, memY% + 179), 14, BF
		LINE (memX% + 40, memY% + 80)-(memX% + 140, memY% + 180), 0, B
		LINE (memX% + 40, memY% + 120)-(memX% + 140, memY% + 180), 0, B
		LINE (memX% + 40, memY% + 160)-(memX% + 140, memY% + 180), 0, B
		w "100%", memX% + 160, memY% + 40, 1, 0, 0
		w "50%", memX% + 160, memY% + 100, 14, 0, 0
		w "0%", memX% + 160, memY% + 170, 4, 0, 0
		button2 memX% + 190, memY% + 170, 0, "OK", 0
		MouseShow
DO
			MouseStatus Lb%, Rb%, cx%, dx%

IF Lb% = -1 THEN
		IF MouseLimit(memX%, memY%, 350, 15) THEN
			 IF MouseLimit(memX% + 260 - 19, memY% + 3, 15, 15) = -1 THEN
		mousehide
		Place.Icon memX% + 260 - 19, memY% + 4, path$ + "\system\close2.rti"
		DO
		 MouseStatus Lb%, Rb%, cx%, dx%
		LOOP WHILE Lb% = -1
		Place.Icon memX% + 260 - 19, memY% + 3, path$ + "\system\close1.rti"
		PUT (memX%, memY%), GetBehind, PSET
		MouseShow
	 EXIT SUB
			ELSE
		 mousehide
		 PUT (memX%, memY%), GetBehind, PSET
		 MouseShow
			 MouseStatus Lb%, Rb%, cx%, dx%
			DO
		MouseStatus Lb%, Rb%, cx%, dx%
			 IF cx% > 310 THEN cx% = 319
			 IF dx% > 250 THEN dx% = 249
		'LOCATE 1, 1: PRINT cx%, dx%
		oldcx% = cx%: olddx% = dx%
		mousehide
		GET (oldcx%, olddx%)-(oldcx% + 260, olddx% + 200), GetBehind
		MouseShow
		LINE (cx%, dx%)-(cx% + 260, dx% + 200), 15, B
	
		DO
			 MouseStatus Lb%, Rb%, cx%, dx%
			 IF cx% > 310 THEN cx% = 319
			 IF dx% > 250 THEN dx% = 249
		LOOP WHILE oldcx% = cx% AND olddx% = dx% AND Lb% = -1
			 mousehide
			 PUT (oldcx%, olddx%), GetBehind, PSET
			 MouseShow
			LOOP WHILE Lb% = -1
			memX% = cx%: memY% = dx%
			mousehide
			GOTO redrawmem
			END IF
		END IF
 IF MouseLimit(memX% + 190, memY% + 170, 60, 20) THEN
		mousehide
		button2 memX% + 190, memY% + 170, 1, "OK", 0
		MouseShow
		DO
				MouseStatus Lb%, Rb%, cx%, dx%
		LOOP WHILE Lb% = -1
		mousehide
		PUT (memX%, memY%), GetBehind, PSET
		EXIT SUB
 END IF
		 
		END IF
	 'END IF
'END IF
	
LOOP UNTIL INKEY$ = CHR$(27)

ELSEIF ScriptName$ = "&FIND_MODULE1" THEN
		mousehide
		EraseStart
		Box 7, 50, 100, 400, 400, "Find Files", 15, 0, 0, 1, 1, 0
		w "Find Files", 70, 130, 0, 0, 15
		w "Named:", 70, 150, 0, 0, 0
		w "Look in:", 70, 170, 0, 0, 0
		x = 140: y = 147: chrs = 18
		LINE (x + 1, y + 1)-(x + (chrs * 8) - 1, y + 11), 15, BF
		LINE (x, y)-(x + (chrs * 8), y + 12), 8, B
		LINE (x + 1, y + 12)-(x + (chrs * 8) - 1, y + 12), 15
		LINE (x + (chrs * 8), y + 1)-(x + (chrs * 8), y + 12), 15

		x = 140: y = 170: chrs = 18
		LINE (x + 1, y + 1)-(x + (chrs * 8) - 1, y + 11), 15, BF
		LINE (x, y)-(x + (chrs * 8), y + 12), 8, B
		LINE (x + 1, y + 12)-(x + (chrs * 8) - 1, y + 12), 15
		LINE (x + (chrs * 8), y + 1)-(x + (chrs * 8), y + 12), 15

		button2 310, 140, 0, "Find", 0
		LINE (51, 200)-(399, 200), 8, B
		LINE (52, 201)-(397, 201), 15, B
	
		MouseShow
		DO
			MouseStatus Lb%, Rb%, cx%, dx%

		IF Lb% = -1 THEN
			 IF MouseLimit(310, 140, 80, 23) = -1 THEN
		mousehide
		LINE (60, 210)-(390, 380), 15, BF
		runz = MouseInOut(310, 140, "Find", 1)
		LINE (60, 385)-(180, 395), 7, BF
		MouseShow
		'ChangeCursor "C"
		SHELL "DIR " + Lookin$ + SearchString$ + " /S /B > TMP\STR.TMP"
		MouseDriver 0, 0, 0, 0
		CLOSE #6
		OPEN path$ + "\TMP\STR.TMP" FOR INPUT AS #6
		sy% = 215
		 DO
			 INPUT #6, outdata$
			 sy% = sy% + 10
				w outdata$, 80, sy%, 0, 0, 0
			IF sy% > 350 THEN
				w "(Press Space to view next, ESC to stop)", 70, 370, 4, 0, 0
		 DO
			Kb$ = INKEY$
			SELECT CASE (Kb$)
				 CASE CHR$(27)
			w "Search stopped.", 60, 385, 0, 0, 0
			GOTO StopFind
				 CASE " ": EXIT DO
			END SELECT
		LOOP WHILE Kb$ = ""
				LINE (60, 210)-(390, 380), 15, BF
				sy% = 215
			END IF
		 LOOP UNTIL EOF(6)
StopFind:
		CLOSE #6
		KILL path$ + "\TMP\STR.TMP"
		MouseShow
			 END IF
			 IF MouseLimit(400 - 16, 103, 10, 10) = -1 THEN
		mousehide
		Place.Icon 400 - 19, 100 + 4, path$ + "\system\close2.rti"
		DO
		 MouseStatus Lb%, Rb%, cx%, dx%
		LOOP WHILE Lb% = -1
		Place.Icon 400 - 19, 100 + 4, path$ + "\system\close1.rti"
		MouseShow
		redraw
		EXIT SUB
			END IF
			IF MouseLimit(140, 170, 18 * 8, 15) = -1 THEN
			 mousehide
			 ibox 140, 170, 18, 17
			 Lookin$ = text1$
			 IF "\" <> LEFT$(Lookin$, 1) THEN Lookin$ = Lookin$ + "\"
			 MouseShow
			END IF
			IF MouseLimit(140, 147, 18 * 8, 15) = -1 THEN
			 mousehide
			 ibox 140, 147, 18, 17
			 SearchString$ = text1$
			 MouseShow
			END IF

		END IF
		LOOP
END IF

END SUB

