' This program demonstrates one of the GUI elements I have programmed
' for myself. It's a graphical pull-down menu, and uses the Windows 95
' font (MS Sans Serif and MS Serif), which I have copied shamelessly.
' Sorry, very good guys at Microsoft! ;) The font is in the sans.fnt file.
' Make sure the FontFile$ holds the right path, otherwise thing no work.

'ͻ
'MAKE SURE YOU'VE LOADED QUICKBASIC WITH THE \L PARAMETER FOR THE LIBRARY!
'ͼ

' For an explanation of each SUB and FUNCTION, see the SUBs and FUNCTIONs
' themselves.

' I give this to the public domain, with the understanding that no money
' should be made of this. Use it, modify it or improve as much you like,
' but do give me credit where it's due. Thanks! :)
'                                                            Marco Hokke

DECLARE SUB AboutProg ()
DECLARE SUB AboutMe ()
DECLARE FUNCTION PopMenu! (Count!)
DECLARE SUB MakeMenu ()
DECLARE SUB InitiateDesktop ()
DECLARE SUB RestoreArea (FileName$)
DECLARE SUB SaveArea (xb%, yb%, xl%, yl%, FileName$)
DECLARE FUNCTION ChangeChar$ (in$, asci1!, asci2!)
DECLARE FUNCTION NoChar$ (in$, asci!)
DECLARE SUB wacht (secs!)
DECLARE SUB MouseClear ()
DECLARE SUB DrawBox (Xc%, yc%, XLength%, YLength%, colour!, Shadow!, Dooble!)
DECLARE SUB MouseHide ()
DECLARE SUB MouseShow ()
DECLARE SUB PrintThis (text$, x!, y!, colour1!, colour2!, mode$)
DECLARE SUB LoadFont ()
DECLARE FUNCTION NOC! ()
DECLARE SUB Mouse (aa%, bb%, cc%, dd%)
DECLARE FUNCTION length! (in$, mode$)

TYPE Registers          'used for the mouse.
     ax AS INTEGER
     bx AS INTEGER
     cx AS INTEGER
     dx AS INTEGER
     bp AS INTEGER
     si AS INTEGER
     di AS INTEGER
     flags AS INTEGER
     ds AS INTEGER
     es AS INTEGER
END TYPE

TYPE g                  'used for the menu's coordinates and contents
   x AS SINGLE
   length AS INTEGER
   text AS STRING * 20
END TYPE

NumberOfMenuItemsInBar = 9
NOM = NumberOfMenuItemsInBar
DIM SHARED MenuItems
DIM SHARED Menus(NOM)
DIM SHARED MenuItem$(NOM, 15)
DIM SHARED MenuItemY(NOM, 15)
DIM SHARED Menu(NOM) AS g

Menu(1).text = "File"
   MenuItem$(1, 1) = "New Program"
   MenuItem$(1, 2) = "Open Program..."
   MenuItem$(1, 3) = "Merge..."
   MenuItem$(1, 4) = "Save"
   MenuItem$(1, 5) = "Save As..."
   MenuItem$(1, 6) = "Save All"
   MenuItem$(1, 7) = "-"
   MenuItem$(1, 8) = "Create File..."
   MenuItem$(1, 9) = "Load File..."
   MenuItem$(1, 10) = "Unload File..."
   MenuItem$(1, 11) = "-"
   MenuItem$(1, 12) = "Print..."
   MenuItem$(1, 13) = "Dos Shell"
   MenuItem$(1, 14) = "-"
   MenuItem$(1, 15) = "Exit"
   Menus(1) = 15
Menu(2).text = "Edit"
   MenuItem$(2, 1) = "Undo"
   MenuItem$(2, 2) = "Cut"
   MenuItem$(2, 3) = "Copy"
   MenuItem$(2, 4) = "Paste"
   MenuItem$(2, 5) = "Clear"
   MenuItem$(2, 6) = "-"
   MenuItem$(2, 7) = "New SUB..."
   MenuItem$(2, 8) = "New FUNCTION..."
   Menus(2) = 8
Menu(3).text = "View"
   MenuItem$(3, 1) = "SUBs..."
   MenuItem$(3, 2) = "Next SUB"
   MenuItem$(3, 3) = "Split"
   MenuItem$(3, 4) = "-"
   MenuItem$(3, 5) = "Next Statement"
   MenuItem$(3, 6) = "Output Screen"
   MenuItem$(3, 7) = "-"
   MenuItem$(3, 8) = "Included File"
   MenuItem$(3, 9) = "Included Lines"
   Menus(3) = 9
Menu(4).text = "Search"
   MenuItem$(4, 1) = "Find"
   MenuItem$(4, 2) = "Selected Text"
   MenuItem$(4, 3) = "Repeat Last Find"
   MenuItem$(4, 4) = "Change..."
   MenuItem$(4, 5) = "Label..."
   Menus(4) = 5
Menu(5).text = "Run"
   MenuItem$(5, 1) = "Start"
   MenuItem$(5, 2) = "Restart"
   MenuItem$(5, 3) = "Continue"
   MenuItem$(5, 4) = "Modify COMMAND$..."
   MenuItem$(5, 5) = "-"
   MenuItem$(5, 6) = "Make EXE File..."
   MenuItem$(5, 7) = "Make Library..."
   MenuItem$(5, 8) = "-"
   MenuItem$(5, 9) = "Set Main Module"
   Menus(5) = 9
Menu(6).text = "Debug"
   MenuItem$(6, 1) = "Add Watch..."
   MenuItem$(6, 2) = "Instant Watch.."
   MenuItem$(6, 3) = "Watchpoint..."
   MenuItem$(6, 4) = "Delete Watch"
   MenuItem$(6, 5) = "Delete All Watch"
   MenuItem$(6, 6) = "-"
   MenuItem$(6, 7) = "Trace On"
   MenuItem$(6, 8) = "History On"
   MenuItem$(6, 9) = "-"
   MenuItem$(6, 10) = "Toggle Breakpoint"
   MenuItem$(6, 11) = "Clear All Breakpoints"
   MenuItem$(6, 12) = "Break On Errors"
   MenuItem$(6, 13) = "Set Next Statement"
   Menus(6) = 13
Menu(7).text = "Calls"
   MenuItem$(7, 1) = "MENUWORK.BAS"
   Menus(7) = 1
Menu(8).text = "Options"
   MenuItem$(8, 1) = "Display..."
   MenuItem$(8, 2) = "Set Paths..."
   MenuItem$(8, 3) = "Right Mouse..."
   MenuItem$(8, 4) = "Syntax Checking"
   MenuItem$(8, 5) = "Full Menus"
Menus(8) = 5
Menu(9).text = "Info"
   MenuItem$(9, 1) = "About This Program"
   MenuItem$(9, 2) = "About The Author"
Menus(9) = 2
MenuItems = 9

DIM SHARED FontFile$
FontFile$ = "c:\windows\desktop\mydocu~1\basics\menuwork\serif.fnt"
DIM SHARED numb(256)             'Holding ascii values of characters
DIM SHARED a$(NOC)               'Holding the 0's and 1's of the characters
DIM SHARED wid(NOC)              'Holding the width of each character
CONST Pi = 3.14152965#
CONST False = 0, True = NOT False

ON TIMER(10) GOSUB TimeUpDate
TIMER ON

CALL InitiateDesktop
CALL MakeMenu
CALL MouseShow

'the interface is all drawn up now. your program should merge with the
'do-loop below. this is where is waited for either a keystroke, or a
'mousebuttonpress. though this program only allows for selecting the menu
'with the mouse and not with Alt+Key, this can be integrated easily. do so
'at your own will... one must leave something for others to do.

DO
  DO
    CALL MouseShow
      DO
        a% = 3
        b% = 0
        C% = 0
        D% = 0
        CALL Mouse(a%, b%, C%, D%)
        E$ = INKEY$
      LOOP WHILE E$ = "" AND b% = 0

    IF E$ = CHR$(27) THEN END
   
    IF D% < 18 AND D% > 1 THEN   'mousebutton is pressed inside bar
      FOR Count = 1 TO MenuItems
        IF C% > Menu(Count).x AND C% < Menu(Count).x + Menu(Count).length THEN
          LINE (150, 300)-(480, 320), 7, BF
          CALL PrintThis(Menu(Count).text, 150, 300, 0, 7, "b")
          Result = PopMenu(Count)
          EXIT FOR
        END IF
      NEXT Count
    END IF

  LOOP WHILE Result = 0 'no item in the menu bar was selected

  '========================================================= File
  'I would have a SELECT CASE Count and inside each CASE, I would nest
  'a SELECT CASE Result, but I'm not going to tell you how to program.
  'The variable Count now holds the value of the menu item from the
  'menu bar. Result holds the value of the item in the pull-down menu
  'that was selected.
         
  LINE (150, 300)-(480, 320), 7, BF
  CALL PrintThis(MenuItem$(Count, Result), 150, 300, 0, 7, "b")
 
  IF Count = 1 AND Result = 15 THEN END 'Exit is selected from the File menu

  IF Count = 9 THEN
    
    SELECT CASE Result

      CASE 1
         'info about this program
         CALL AboutProg
     
      CASE 2
         'info about the author
         CALL AboutMe

      CASE ELSE
   
    END SELECT

  END IF

  Count = 0
  Result = 0

LOOP


TimeUpDate:
   IF t$ <> LEFT$(TIME$, 5) THEN
      t$ = LEFT$(TIME$, 5)
      D$ = MID$(DATE$, 4, 2) + "-" + LEFT$(DATE$, 2) + "-" + RIGHT$(DATE$, 4)
      LINE (540, 1)-(635, 17), 7, BF
      PrintThis D$ + "  " + t$, 540, 5, 0, 7, "n"
   END IF
   RETURN

SUB AboutMe

CALL SaveArea(180, 180, 320, 160, "prog.sav")

CALL DrawBox(190, 190, 300, 132, 7, True, True)

PrintThis "This program was made by Marco Hokke, citizen of", 200, 200, 0, 7, "n"
PrintThis "Leiden, Holland. If you want to contact me, here's", 200, 218, 0, 7, "n"
PrintThis "my email address:", 200, 236, 0, 7, "n"
PrintThis "Hokje@yahoo.co.uk", 200, 272, 0, 7, "n"
PrintThis "Press a key to continue.", 340, 308, 0, 7, "n"

CALL wacht(0)

CALL RestoreArea("prog.sav")

END SUB

SUB AboutProg

CALL SaveArea(180, 180, 320, 170, "prog.sav")

CALL DrawBox(190, 190, 300, 150, 7, True, True)

PrintThis "This program was built in QuickBasic 4.5 with the", 200, 200, 0, 7, "n"
PrintThis "QB library for mouse-support. The original program", 200, 218, 0, 7, "n"
PrintThis "also had a sophisticated dialogue-box, but that code", 200, 236, 0, 7, "n"
PrintThis "is too messy to put on the Internet. If you want, you", 200, 254, 0, 7, "n"
PrintThis "can get it from me. Please contact me if you do.", 200, 272, 0, 7, "n"
PrintThis "For more info about how this works, see the comments", 200, 290, 0, 7, "n"
PrintThis "inside.", 200, 308, 0, 7, "n"
PrintThis "Press a key to continue.", 340, 326, 0, 7, "n"

CALL wacht(0)

CALL RestoreArea("prog.sav")
END SUB

FUNCTION ChangeChar$ (in$, asci1, asci2)
'changes each occurence of chr$(asci1) in In$ into chr$(asci2)

 FOR Count = 1 TO LEN(in$)
  IF ASC(MID$(in$, Count, 1)) = asci1 THEN
   MID$(in$, Count, 1) = CHR$(asci2)
  END IF
 NEXT Count

 ChangeChar$ = in$

END FUNCTION

SUB DrawBox (Xc%, yc%, XLength%, YLength%, colour, Shadow, Dooble)
'Draws a graphical box at specified coordinates.
'
'  Colour :    Fill colour of the box
'  Shadow :    True for 'inwards', False for 'outwards'
'  Dooble :    True for deeper box, False for flatter box

IF Shadow = True THEN            'If the box has to go outwards
   'colour1 = 15                  'SCREEN 9
   colour1 = 14                  'SCREEN 12make the top colour white,
   colour2 = 8                   'and base colour black;
   colour3 = 15
   colour4 = 0
ELSE                             'or go inwards, and
   colour1 = 8                   'make the top colour black,
   'colour2 = 15
   colour2 = 14                  'and base colour white.
   colour3 = 0
   colour4 = 15
END IF

IF Dooble = True THEN
     LINE (Xc% - 1, yc% - 1)-(Xc% + XLength% + 1, yc% - 1), colour3
     LINE (Xc% + XLength% + 1, yc% - 1)-(Xc% + XLength% + 1, yc% + YLength% + 1), colour4
     LINE (Xc% + XLength% + 1, yc% + YLength% + 1)-(Xc% - 1, yc% + YLength% + 1), colour4
     LINE (Xc% - 1, yc% + YLength% + 1)-(Xc% - 1, yc% - 1), colour3
ELSE
   IF Shadow = True THEN
      colour1 = 15
      colour2 = 0
   ELSE
      colour1 = 0
      colour2 = 15
   END IF
END IF

LINE (Xc%, yc%)-(Xc% + XLength%, yc% + YLength%), colour, BF
LINE (Xc%, yc%)-(Xc% + XLength%, yc%), colour1
LINE (Xc% + XLength%, yc%)-(Xc% + XLength%, yc% + YLength%), colour2
LINE (Xc% + XLength%, yc% + YLength%)-(Xc%, yc% + YLength%), colour2
LINE (Xc%, yc% + YLength%)-(Xc%, yc%), colour1

END SUB

SUB InitiateDesktop
'Sets the palettes for the colours that are used. 1, 13, 14 and 15 are
'modified. Also, the screen is built (with that nice cyan colour), and the
'(empty) menubar is drawn.

CALL LoadFont
SCREEN 12
CLS

PALETTE 1, 30 * 65536 + 10 * 256 + 10
PALETTE 15, 57 * 65793
PALETTE 14, 52 * 65793
PALETTE 13, 47 * 65793

PAINT (1, 1), 3

LINE (0, 19)-(640, 19), 0
LINE (0, 18)-(640, 18), 8
LINE (0, 17)-(640, 0), 7, BF
CIRCLE (4, 4), 4, 0, (.5 * Pi), Pi: PAINT (0, 0), 0
CIRCLE (635, 4), 4, 0, 0, (.5 * Pi): PAINT (639, 0), 0
CIRCLE (4, 475), 4, 0, Pi, (1.5 * Pi): PAINT (1, 479), 0
CIRCLE (635, 475), 4, 0, (1.5 * Pi), (2 * Pi): PAINT (639, 479), 0

'Now make some mess, so that it's clear that the background is preserved.

CALL DrawBox(20, 40, 500, 300, 7, False, True)

CALL PrintThis("The font-routine is not a versatile as some I've seen", 40, 60, 4, 7, "b")
CALL PrintThis("But it's neat and tidy, and it works fast enough.", 200, 90, 1, 7, "n")
CALL PrintThis("Try the other font included here, 'serif.fnt', which is", 185, 120, 9, 7, "n")
CALL PrintThis("a different typeface. Just change the FontFile$!", 60, 150, 14, 7, "b")

CALL PrintThis("For now, just select a menu item and then another one from its pull-down menu.", 40, 200, 0, 7, "n")

CALL PrintThis("You have selected:", 30, 300, 0, 7, "b")
END SUB

FUNCTION length (in$, mode$)
'calculates the length of In$ in pixels (goes for the font loaded).

'mode$ is "normal", "roman", "n", or "r" for normal text, or
'"bold", "b" for bold text.

Total = 0
mode$ = LCASE$(mode$)

SELECT CASE mode$
   CASE "normal", "roman", "n", "r"

      FOR Count = 1 TO LEN(in$)
         TOE$ = MID$(in$, Count, 1)
         Code = numb(ASC(TOE$))
         BREED = wid(Code)
         Total = Total + BREED
         Total = Total + 1
      NEXT Count

   CASE "bold", "b"
      FOR Count = 1 TO LEN(in$)
         TOE$ = MID$(in$, Count, 1)
         Code = numb(ASC(TOE$))
         BREED = wid(Code)
         Total = Total + BREED
         Total = Total + 2
      NEXT Count

   CASE ELSE

END SELECT
length = Total

END FUNCTION

SUB LoadFont
'this sub loads the font into arrays. If you look at sans.fnt in NotePad,
'you will see immediately how the file is built up. The order of characters
'is irrelevant, but do put the total number of characters on the first line.

OPEN FontFile$ FOR INPUT AS #1
INPUT #1, Number
FOR K = 1 TO Number
 INPUT #1, ASCII
 numb(ASCII) = K
 INPUT #1, wid(K)
 FOR Count = 1 TO 11
  LINE INPUT #1, TOE$
  a$(K) = a$(K) + TOE$
 NEXT Count
NEXT K
CLOSE #1

END SUB

'Draws just the menu items in the menu bar. The menubar is created
'in the InitiateDesktop sub. In this sub, the parameters of Menu().xxx are
'also filled with their appropriate values.
'MCH '98
SUB MakeMenu

   Distance = 10              'Distance between items in the bar
   Xc = 10                    'X-coordinate of first item (from the left)

   FOR Count = 1 TO MenuItems
      CALL PrintThis(Menu(Count).text, Xc, 5, 0, 7, "n")
      Menu(Count).x = Xc
      Menu(Count).length = length(LTRIM$(RTRIM$(Menu(Count).text)), "n")
      Xc = Xc + Menu(Count).length + Distance
   NEXT Count

   t$ = LEFT$(TIME$, 5)
   D$ = MID$(DATE$, 4, 2) + "-" + LEFT$(DATE$, 2) + "-" + RIGHT$(DATE$, 4)
   LINE (540, 1)-(635, 17), 7, BF
   PrintThis D$ + "  " + t$, 540, 5, 0, 7, "n"

END SUB

SUB Mouse (aa%, bb%, cc%, dd%)
'most basic mouse function around. puts things in, takes things out.

 DIM Muis AS Registers

 Muis.ax = aa%
 Muis.bx = bb%
 Muis.cx = cc%
 Muis.dx = dd%
 CALL interrupt(51, Muis, Muis)
 aa% = Muis.ax
 bb% = Muis.bx
 cc% = Muis.cx
 dd% = Muis.dx

END SUB

SUB MouseClear
'waits for a mouse button to be released (when selecting from the pull-down
'menus, and (in other programs) when pressing a button).

DO
 a% = 3
 b% = 0
 CALL Mouse(a%, b%, 0, 0)
LOOP WHILE b% <> 0

END SUB

SUB MouseHide
'duhhh, hides the mouse cursor?

 CALL Mouse(2, 0, 0, 0)

END SUB

SUB MouseShow
'duhhh, shows the mouse cursor?

 CALL Mouse(1, 0, 0, 0)

END SUB

FUNCTION NOC
'gets the Number Of Characters from the font file (sans.fnt).

Fonts = FREEFILE
OPEN FontFile$ FOR INPUT AS #Fonts
 INPUT #Fonts, NOC
CLOSE #Fonts

END FUNCTION

FUNCTION NoChar$ (in$, asci)
'In$ is ripped of each occurence of chr$(asci). It is not replaced by a space.

 Help$ = ""

 FOR Count = 1 TO LEN(in$)
  IF MID$(in$, Count, 1) <> CHR$(asci) THEN
   Help$ = Help$ + MID$(in$, Count, 1)
  END IF
 NEXT Count

 NoChar$ = Help$

END FUNCTION

FUNCTION PopMenu (Count)

FOR Counta = 1 TO Menus(Count)
   IF MenuItem$(Count, Counta) <> "-" THEN
      IF leng% < length(MenuItem$(Count, Counta), "n") + 30 THEN
         leng% = length(MenuItem$(Count, Counta), "n") + 30
      END IF
      Height% = Height% + 18
   ELSE
      Height% = Height% + 6
   END IF
NEXT Counta

 IF leng% < 120 THEN leng% = 120
 Height% = Height% + 1
 x% = Menu(Count).x
 y% = 20

 CALL MouseHide
 CALL SaveArea(x% - 5, 1, leng% + 10, Height% + 25, "Menu.sav")

 LINE (Menu(Count).x - 5, 1)-(Menu(Count).x + Menu(Count).length + 5, 16), 1, BF
 CALL PrintThis(RTRIM$(Menu(Count).text), Menu(Count).x, 5, 15, 1, "n")

 CALL DrawBox(x%, y%, leng%, Height%, 7, True, False)

 y = 4

 FOR Countc = 1 TO Menus(Count)

   IF MenuItem$(Count, Countc) = "-" THEN
   
      LINE (x% + 2, y% + y - 1)-(x% + leng% - 2, y% + y - 1), 8
      LINE (x% + 2, y% + y)-(x% + leng% - 2, y% + y), 15
      MenuItemY(Count, Countc) = -1
      y = y + 6

   ELSE
   
      CALL PrintThis(MenuItem$(Count, Countc), x% + 15, y% + y, 0, 7, "n")
      MenuItemY(Count, Countc) = y% + y
      y = y + 18

   END IF

 NEXT Countc

 CALL MouseShow

DO
 DO
  a% = 3
  b% = 0
  C% = 0
  D% = 0
  CALL Mouse(a%, b%, C%, D%)
  E$ = INKEY$
 LOOP WHILE b% = 0 AND E$ = ""

 IF E$ = CHR$(27) THEN
      
   CALL MouseHide
   PopMenu = 0
   CALL MouseHide
   CALL RestoreArea("Menu.sav")
   CALL MouseShow
   EXIT FUNCTION

 END IF

 IF C% > x% AND C% < x% + leng% THEN

   FOR Countc = 1 TO Menus(Count)

      IF D% > MenuItemY(Count, Countc) - 2 AND D% < MenuItemY(Count, Countc) + 17 THEN

         'Print the selected item in white on blue
         CALL MouseHide
         LINE (x% + 2, MenuItemY(Count, Countc) - 3)-(x% + leng% - 2, MenuItemY(Count, Countc) + 13), 1, BF
         CALL PrintThis(MenuItem$(Count, Countc), x% + 15, MenuItemY(Count, Countc), 15, 1, "n")
      
         PopMenu = Countc
      
         'Wait for the user to release the mouse button
         CALL MouseShow
         CALL MouseClear
      
         'Restore the selected item in black on gray
         CALL MouseHide
         LINE (x% + 2, MenuItemY(Count, Countc) - 3)-(x% + leng% - 2, MenuItemY(Count, Countc) + 13), 7, BF
         CALL PrintThis(MenuItem$(Count, Countc), x% + 15, MenuItemY(Count, Countc), 0, 7, "n")
      
         EXIT DO

      END IF

   NEXT Countc

   PopMenu = 0
   EXIT DO

 ELSE

   PopMenu = 0
   EXIT DO

 END IF

LOOP

 CALL MouseHide
 CALL RestoreArea("Menu.sav")
 CALL MouseShow

END FUNCTION

SUB PrintThis (text$, x, y, colour1, colour2, mode$)
'Prints Text$ at a specified location.
'  colour1 :      the colour of the text
'  colour2 :      the background colour (NOT covering all of background!)
'  mode$   :      see Length FUNCTION for details.

 xbegin = x
 L = LEN(text$)
 mode$ = LCASE$(mode$)
 CALL MouseHide
 SELECT CASE mode$
 
  CASE "normal", "roman", "n", "r"
   FOR Count = 1 TO L
   ASCII = ASC(MID$(text$, Count, 1))
    FOR count1 = 1 TO 11
     factor = (count1 - 1) * wid(numb(ASCII))
     FOR COUNT2 = 1 TO wid(numb(ASCII))
      IF MID$(a$(numb(ASCII)), COUNT2 + factor, 1) = "1" THEN
       PSET (xbegin + COUNT2, y - 1 + count1), colour1
      ELSE
       PSET (xbegin + COUNT2, y - 1 + count1), colour2
      END IF
     NEXT
    NEXT
    xbegin = xbegin + wid(numb(ASCII)) + 1
    LINE (xbegin, y)-(xbegin, y + 10), colour2
   NEXT

  CASE "bold", "b"
   FOR Count = 1 TO L
    ASCII = ASC(MID$(text$, Count, 1))
    FOR count1 = 1 TO 11
     factor = (count1 - 1) * wid(numb(ASCII))
     FOR COUNT2 = 1 TO wid(numb(ASCII))
      IF MID$(a$(numb(ASCII)), COUNT2 + factor, 1) = "1" THEN
       PSET (xbegin + COUNT2, y - 1 + count1), colour1
       PSET (xbegin + COUNT2 + 1, y - 1 + count1), colour1
      END IF
     NEXT
    NEXT
    xbegin = xbegin + wid(numb(ASCII)) + 2
    LINE (xbegin, y)-(xbegin, y + 10), colour2
   NEXT

  CASE ELSE
 END SELECT

 CALL MouseShow

END SUB

SUB RestoreArea (FileName$)
'Restores an area of the graphic screen pixel by pixel, as was saved in
'FileName$.

FileNo = FREEFILE

OPEN FileName$ FOR INPUT AS #FileNo


INPUT #FileNo, xb%
INPUT #FileNo, yb%
INPUT #FileNo, xl%
INPUT #FileNo, yl%


FOR countx = xb% - 1 TO xb% + xl%

  FOR county = yb% - 1 TO yb% + yl%

    INPUT #FileNo, Col$
    PSET (countx + 1, county + 1), ASC(Col$) - 65

  NEXT county

NEXT countx


CLOSE #FileNo

END SUB

SUB SaveArea (xb%, yb%, xl%, yl%, FileName$)
'Saves the area from xb% to xb% + xl% and from yb% to yb% + yl%.
'It saves the colour of each individual pixel in FileName$

FileNo = FREEFILE
OPEN FileName$ FOR OUTPUT AS #FileNo


PRINT #FileNo, xb% - 1     'the coordinates of the area that is saved.
PRINT #FileNo, yb% - 1
PRINT #FileNo, xl% + 2
PRINT #FileNo, yl% + 2


FOR countx% = xb% - 1 TO xb% + xl% + 2

  FOR county% = yb% - 1 TO yb% + yl% + 2

    Co% = POINT(countx%, county%)
    PRINT #FileNo, CHR$(Co% + 65)

  NEXT county%

NEXT countx%


CLOSE #FileNo


END SUB

SUB wacht (secs)
'waits secs seconds. secs can have three values:
'
'  positive :     sub waits for either secs seconds, or untill a keystroke;
'  zero     :     sub waits for a keystroke;
'  negative :     sub waits for secs seconds only.

 SELECT CASE secs

  CASE IS < 0
   t = TIMER + ABS(secs)
   DO
   LOOP WHILE t > TIMER
   EXIT SUB

  CASE 0
   DO
    b$ = INKEY$
   LOOP WHILE b$ = ""
   EXIT SUB

  CASE IS > 0
   t = TIMER + secs
   DO
    b$ = INKEY$
   LOOP WHILE b$ = "" AND t < TIMER
   EXIT SUB

  CASE ELSE
 END SELECT

END SUB

