DECLARE SUB playwav (wavefile$, watp&)
'==========================================================================
'Programmed by: Lord Agnathian, Angel Rift Productions
'
'TEST ME FIRST, PRESS F5
'
'This is a REAL easy to use wav play for QBasic
'Are you tired of downloading all those wav players, only
'to find out your actually getting LITERALLY an entire wav player, when
'all you need is a simple program to play a small sound effect.
'This is your answer, with only one sub, it detects your soundcard and
'plays the first buffer from 1 to your programs memory limitation(usually
'32000) bytes.
'
'SYNTAX: "PLAYWAV wavefile$, buffer"
'         if the file is under 30000, you could try using -1 switch which
'         will automatically set the buffer to the size of the file.
'
'PRO's
' 1) 1 SUB!
' 2) NO CONSTANT\VARIABLES NEEDED!
' 3) AUTO DETECTS SOUNDCARD, DMA, BASE, IRQ!
' 4) SIMPLE, EASY, & FAST!
'
'CON's
' 1) NOT tested on all machines, but works great on both
'    of mine(2 different types of sound cards too).
' 2) Can only play 8 bit mono PCM format(from 8000-48000Mhz).
' 3) Only plays 1st buffer
'
'Remember, this is not a player, it does not play long waves, only
'simple sound effects needed for your programs.  Have fun!
'
'NOW that I HOPE you read this, you can delete all these remark lines, this
'program is supposed to GIVE you space, not take it up by remark lines :)
'==========================================================================

'CLS
'playwav "sword.wav", -1
'playwav "\windows\media\themic~1.wav", -1
'playwav "\windows\media\themic~1.wav", -1
'playwav "\windows\media\trekques.wav", -1
'playwav "\windows\media\chord.wav", -1

DEFINT A-Z
SUB playwav (wavefile$, watp&)
    IF INSTR(wavefile$, ".") = 0 THEN wavefile$ = wavefile$ + ".wav"
    repeats% = 1
    tmp% = 0
    blast$ = UCASE$(ENVIRON$("BLASTER"))
    IF LEN(blast$) THEN
        tmp% = INSTR(blast$, "A")
        tmp1$ = MID$(blast$, tmp% + 1, 3)
        tmp% = VAL("&H" + tmp1$)
        IF tmp% = 203 THEN tmp% = -1
        IF tmp% > 0 THEN
            tmp2% = INSTR(blast$, "D")
            dma% = VAL(MID$(blast$, tmp2% + 1))
            IF dma% < 0 OR dma% > 7 THEN tmp% = -2
        END IF
    END IF
    BlasterAddr% = tmp%
    sp% = INSTR(Spec$, " ")
    IF sp% THEN
        wavefile$ = LEFT$(Spec$, sp% - 1)
        repeats% = VAL(RIGHT$(Spec$, LEN(Spec$) - sp%))
        IF repeats% = 0 THEN repeats% = 1
    ELSE
        IF LEN(Spec$) THEN
            wavefile$ = Spec$
            repeats% = 1
        END IF
    END IF
    IF LEN(wavefile$) = 0 THEN
       EXIT SUB
    END IF
    rID$ = SPACE$(4)
    wID$ = SPACE$(4)
    fID$ = SPACE$(4)
    dat$ = SPACE$(4)
    dummy$ = SPACE$(1)
    filenum% = FREEFILE
    OPEN wavefile$ FOR BINARY AS filenum%
    IF watp& = -1 THEN watp& = LOF(filenum%)
    GET filenum%, , rID$
    GET filenum%, , rLen&
    GET filenum%, , wID$
    GET filenum%, , fID$
    GET filenum%, , fLen&
    GET filenum%, , wFormatTag%
    GET filenum%, , Channels%
    GET filenum%, , Sampling&
    GET filenum%, , bytes&
    GET filenum%, , nBlockAlign%
    GET filenum%, , FormatSpecific%
    FOR i% = 1 TO fLen& - 16
        GET filenum%, , dummy$
    NEXT i%
    GET filenum%, , dat$
    IF UCASE$(dat$) = "FACT" THEN
        GET filenum%, , dummy&
        GET filenum%, , dummy&
        GET filenum%, , dat$
    END IF
    GET filenum%, , WavLen&
    LenHeader% = LOC(1)
    CLOSE filenum%
    IF UCASE$(rID$) = "RIFF" THEN
        IF UCASE$(wID$) = "WAVE" THEN
            IF UCASE$(dat$) = "DATA" THEN
                IF UCASE$(fID$) = "FMT " THEN
                    IF FormatSpecific% = 8 THEN ok% = -1
                END IF
            END IF
        END IF
    END IF
    DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
    OUT BlasterAddr% + &HC, &HD1'Speaker ON
    filenum% = FREEFILE
    OPEN wavefile$ FOR BINARY AS filenum%
    Num% = 0
    SEEK filenum%, LenHeader% + 1
    Remaining& = WavLen&
    Num% = Num% + 1
    IF Remaining& > watp& THEN
        bufferlen& = watp&
    ELSE
        bufferlen& = Remaining&
    END IF
    Remaining& = Remaining& - bufferlen&
  'buffer$ = ""
10
    IF bufferlen& > 32000 THEN
       buffer$ = SPACE$(32000)
    ELSE
        IF bufferlen& > 0 THEN buffer$ = SPACE$(bufferlen&) ELSE GOTO 20
    END IF
'10
    GET filenum%, , buffer$
    bufferlen& = bufferlen& - 1
    Segment& = VARSEG(buffer$)
    Offset& = SADD(buffer$)
    IF Segment& < 0 THEN Segment& = Segment& + 65536
    IF Offset& < 0 THEN Offset& = Offset& + 65536
    baseaddr& = Segment& * 16 + Offset&
    look1% = VARPTR(baseaddr&)
    look2% = VARPTR(bufferlen&)
    SELECT CASE dma%
        CASE 0: dmapage% = &H87: dmaaddr% = 0: dmalen% = 1
        CASE 1: dmapage% = &H83: dmaaddr% = 2: dmalen% = 3
        CASE 2: dmapage% = &H81: dmaaddr% = 4: dmalen% = 5
        CASE 3: dmapage% = &H82: dmaaddr% = 6: dmalen% = 7
        CASE 4: dmapage% = &H8F: dmaaddr% = &HC0: dmalen% = &HC2
        CASE 5: dmapage% = &H8B: dmaaddr% = &HC4: dmalen% = &HC6
        CASE 6: dmapage% = &H89: dmaaddr% = &HC8: dmalen% = &HCA
        CASE 7: dmapage% = &H8A: dmaaddr% = &HCC: dmalen% = &HCE
    END SELECT
    SELECT CASE dma%
        CASE 0 TO 3: dmamask% = &HA: dmamode% = &HB: dmaclear% = &HC: dmastatus% = &H8
        CASE 4 TO 7: dmamask% = &HD4: dmamode% = &HD6: dmaclear% = &HD8: dmastatus% = &HD0
    END SELECT
    SELECT CASE dma%
        CASE 0, 4: dmaterminal% = 1
        CASE 1, 5: dmaterminal% = 2
        CASE 2, 6: dmaterminal% = 4
        CASE 3, 7: dmaterminal% = 8
    END SELECT
    OUT dmamask%, dma% + 4
    OUT dmaclear%, &H0
    OUT dmamode%, 72 + dma%
    OUT dmaaddr%, PEEK(look1%)
    OUT dmaaddr%, PEEK(look1% + 1)
    OUT dmapage%, PEEK(look1% + 2)
    OUT dmalen%, PEEK(look2%)
    OUT dmalen%, PEEK(look2% + 1)
    OUT dmamask%, dma%
    IF Num% = 1 THEN
        timeconst% = 256 - 1000000 / (Sampling& * Channels%)
        DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
        OUT BlasterAddr% + &HC, &H40
        DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
        OUT BlasterAddr% + &HC, timeconst%
        OUT BlasterAddr% + &H4, &H0
        OUT BlasterAddr% + &H4 + 1, 0
        OUT BlasterAddr% + &H4, &H22
        OUT BlasterAddr% + &H4 + 1, 255
        IF Channels% = 2 THEN
            OUT BlasterAddr% + &H4, &HE
            OUT BlasterAddr% + &H4 + 1, 34
        END IF
    END IF
    IF bytes& > 22000 THEN
        DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
        OUT BlasterAddr% + &HC, &H48
    ELSE
        DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
        OUT BlasterAddr% + &HC, &H14
    END IF
    DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
    OUT BlasterAddr% + &HC, PEEK(look2%)
    DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
    OUT BlasterAddr% + &HC, PEEK(look2% + 1)
    IF bytes& > 22000 THEN
        DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
        OUT BlasterAddr% + &HC, &H91
    END IF
    'IF bufferlen& > 0 THEN GOTO 10
20
    dummy% = INP(dmastatus%)
    dummy% = INP(BlasterAddr% + &HE)
    OUT &H20, &H20
    CLOSE filenum%
END SUB

