DECLARE SUB CreateIcon (num!, frm!, x!, y!, fl$, ix!, vis!)
DECLARE SUB CreateLight (num!, frm!, x!, y!, xx!, yy!, vis!)
DECLARE SUB CreateProgress (num!, frm!, x!, y!, xx!, yy!, max!, visible!)
DECLARE SUB CreateForm (num!, x!, y!, xx!, yy!, title$, style$, makeactive!, mkvisible!)
DECLARE SUB reorder (n!)
DECLARE SUB CreateLabel (num!, frm!, x!, y!, xx!, yy!, txt$, c!, visible!)
DECLARE FUNCTION GetTBSize! (num!)
DECLARE SUB APIscreensaver ()
DECLARE SUB APIstatus (a$)
DECLARE SUB DrawButton (num!)
DECLARE SUB DrawIcon (num!)
DECLARE SUB APIerror (APIerr$, critical!, showerror!)
DECLARE SUB APImousecursor (a$)
DECLARE FUNCTION APIcharstring$ (c$, lngth!)
DECLARE FUNCTION APIstringspace! ()
DECLARE FUNCTION APIstackspace! ()
DECLARE FUNCTION APIarrayspace! ()
DECLARE SUB xyformcustom (style$)
DECLARE SUB AMmousehide ()
DECLARE SUB AMmouseshow ()
DECLARE SUB APIwraptext (t$, x!, y!, xx!, yy!, c!)
DECLARE SUB DrawLight (num!)
DECLARE SUB APIwaitforretrace ()
DECLARE SUB Main ()
DECLARE SUB mouseinit ()
DECLARE FUNCTION AMmousex! ()
DECLARE FUNCTION AMmousey! ()
DECLARE FUNCTION AMmouselb! ()
DECLARE FUNCTION AMmouserb! ()
DECLARE SUB MouseDriver (ax%, bx%, cx%, dx%)
DECLARE SUB mouseshow ()
DECLARE SUB mousestatus (lb%, rb%, Xmouse%, Ymouse%)
DECLARE SUB mousehide ()
DECLARE SUB DrawLabel (num!)
DECLARE SUB multitask ()
DECLARE SUB DrawProgress (num!)
DECLARE SUB APItextarea (t$, x!, y!, xx!, yy!)
DECLARE SUB text (t$, x!, y!, c!)
DECLARE SUB initialize ()
DECLARE SUB getinfo ()
DECLARE SUB DrawForm (num!)
DECLARE SUB xyform (x!, y!, xx!, yy!, title$, active!)
DECLARE SUB bevel (x!, y!, xx!, yy!, inout!)
DECLARE SUB forminfo ()
DECLARE SUB refresh ()
DECLARE FUNCTION APItextwidth! (t$)
DECLARE SUB desktop ()
DECLARE SUB dotback (st!)
DECLARE FUNCTION trim$ (a$)
CONST true = -1
CONST false = 0
CONST maxbuttons = 5
CONST maxlights = 5
CONST maxforms = 10
CONST maxlabels = 20
CONST maxprogress = 5
CONST maxicons = 50
CONST formfile$ = "Default"
CONST WSminimized = 64
CONST WSmaximized = 128
CONST WSSizeable = 512
CONST amethystpath$ = "a:\"
'---------------- Should be in Amethyst.INI ----
CONST col3d = 7                  ' 3D Color
CONST col3dH = 15                ' 3D Highlight
CONST col3dHH = 0                ' 3D Extended Higlight
CONST col3dS = 8                 ' 3D Shadow
CONST col3dSS = 0                ' 3D Extended Shadow
CONST col3dmerge = 8             ' 3D Merging Color
CONST coltext = 0                ' General Text Color
CONST tbheight = 15              ' Title Bar Height
CONST colwin16border = 0         ' Win16 Style Border
CONST coltbinactive = 8          ' Inactive Title Bar Color
CONST coltbactive = 1            ' Active Title Bar Color
CONST coltbtext = 15             ' Title Bar Text Color
CONST coldesktop = 1             ' Desktop Color
CONST coldesktoptext = 14        ' Desktop Figure Color
CONST styledotback = 1           ' Desktop Style
CONST screenmode = 12            ' Screen Mode
CONST screenxres = 640           ' Horizontal Resolution
CONST screenyres = 480           ' Vertical Resolution
CONST screendesktopintensity = 2 ' Intensity of Desktop Figures (Inversed)
CONST systemfontengrave = 0      ' Engrave Styling on font?
CONST systemtbtextalign = 2      ' Title Bar Text Alignment
'-----------------------------------------------
ARROWcursor:
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

TIMERcursor:
DATA &HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF
DATA &HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF,&HFFFF
DATA &HFFFF,&H2004,&H2004,&H2004,&H1008,&H990,&H420,&H240
DATA &H240,&H420,&H810,&H1008,&H2084,&H2144,&H22A4,&HFFFF
DATA 5 ,0

TYPE RegType
ax    AS INTEGER
bx    AS INTEGER
cx    AS INTEGER
dx    AS INTEGER
bp    AS INTEGER
si    AS INTEGER
di    AS INTEGER
flags AS INTEGER
END TYPE

TYPE progresstype
x AS INTEGER
y AS INTEGER
xx AS INTEGER
yy AS INTEGER
cur AS INTEGER
max AS INTEGER
form AS INTEGER
lastcur AS INTEGER
visible AS INTEGER
END TYPE
TYPE labeltype
x AS INTEGER
y AS INTEGER
xx AS INTEGER
yy AS INTEGER
text AS STRING * 512
visible AS INTEGER
style AS STRING * 3
form AS INTEGER
colour AS INTEGER
END TYPE
TYPE lighttype
x AS INTEGER
y AS INTEGER
xx AS INTEGER
yy AS INTEGER
onoff AS INTEGER
lastonoff AS INTEGER
form AS INTEGER
visible AS INTEGER
END TYPE
TYPE icontype
x AS INTEGER
y AS INTEGER
file AS STRING * 50
form AS INTEGER
visible AS INTEGER
index AS INTEGER
END TYPE
TYPE formtype
x AS INTEGER
y AS INTEGER
xx AS INTEGER
yy AS INTEGER
title AS STRING * 80
ctrlname AS STRING * 10
visible AS INTEGER
state AS INTEGER
style AS STRING * 8
END TYPE
TYPE buttontype
x AS INTEGER
y AS INTEGER
xx AS INTEGER
yy AS INTEGER
caption AS STRING * 80
visible AS INTEGER
form AS INTEGER
END TYPE
TYPE amsystemtype
internaltimer AS LONG
cursormode AS STRING * 15
forcerefresh AS INTEGER
anmcurtimer AS INTEGER
defaultcursor AS STRING * 12
message AS STRING * 50
END TYPE
DIM SHARED gui$(20, 10)
DIM SHARED w$(10)
DIM SHARED winorder(10)
DIM SHARED label(maxlabels) AS labeltype
DIM SHARED form(maxforms) AS formtype
DIM SHARED Progress(maxprogress) AS progresstype
DIM SHARED Light(maxlights) AS lighttype
DIM SHARED icon(maxicons) AS icontype
DIM SHARED button(maxbuttons) AS buttontype
DIM SHARED MOUSE$
DIM SHARED AMsystem AS amsystemtype
DIM SHARED anmcur$(8)
ON ERROR GOTO errhandle:
GOTO skiperr:
errhandle:
RESUME NEXT
skiperr:
MOUSE$ = SPACE$(57)
FOR I% = 1 TO 57
READ a$
H$ = CHR$(VAL("&H" + a$))
MID$(MOUSE$, I%, 1) = H$
NEXT I%
'--------------------------- Main Loop
initialize
Main

SUB AMmousehide

'|--------------------------------------------------------------------------|'
'| AMmousehide                                                              |'
'|--------------------------------------------------------------------------|'
'| Hides the mouse cursor with a call to MouseDrive                         |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

 ax% = 2
 MouseDriver ax%, 0, 0, 0
END SUB

FUNCTION AMmouselb

'|--------------------------------------------------------------------------|'
'| AMmouselb                                                                |'
'|--------------------------------------------------------------------------|'
'| Returns the mouse left button status:                                    |'
'|                                       0=Unpressed                        |'
'|                                      -1=Pressed                          |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

mousestatus lb%, rb%, Xmouse%, Ymouse%
AMmouselb = lb%
END FUNCTION

FUNCTION AMmouserb

'|--------------------------------------------------------------------------|'
'| AMmouserd                                                                |'
'|--------------------------------------------------------------------------|'
'| Returns the mouse right button status:                                   |'
'|                                       0=Unpressed                        |'
'|                                      -1=Pressed                          |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

mousestatus lb%, rb%, Xmouse%, Ymouse%
AMmouserb = rb%
END FUNCTION

SUB AMmouseshow

'|--------------------------------------------------------------------------|'
'| AMmouseshow                                                              |'
'|--------------------------------------------------------------------------|'
'| Displays the mouse cusor with a call to MouseDriver                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

ax% = 1
MouseDriver ax%, 0, 0, 0
MouseDriver ax%, 0, 0, 0
END SUB

FUNCTION AMmousex

'|--------------------------------------------------------------------------|'
'| AMmousex                                                                 |'
'|--------------------------------------------------------------------------|'
'| Returns the mouse X co-ordinate                                          |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

mousestatus lb%, rb%, Xmouse%, Ymouse%
AMmousex = Xmouse%
END FUNCTION

FUNCTION AMmousey

'|--------------------------------------------------------------------------|'
'| AMmousey                                                                 |'
'|--------------------------------------------------------------------------|'
'| Returns the mouse Y co-ordinate                                          |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

mousestatus lb%, rb%, Xmouse%, Ymouse%
AMmousey = Ymouse%
END FUNCTION

FUNCTION APIarrayspace

'|--------------------------------------------------------------------------|'
'| APIarrayspace                                                            |'
'|--------------------------------------------------------------------------|'
'| Returns the amount of free array space in bytes                          |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

APIarrayspace = FRE(-1)
END FUNCTION

FUNCTION APIcharstring$ (c$, lngth)

'|--------------------------------------------------------------------------|'
'| APIcharstring                                                            |'
'|--------------------------------------------------------------------------|'
'| Returns a string filled with c$. The length is supplied in lngth         |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

FOR n = 1 TO lngth
a$ = a$ + c$
NEXT
APIcharstring$ = a$
END FUNCTION

SUB APIerror (APIerr$, critical, showerror)

'|--------------------------------------------------------------------------|'
'| APIerror                                                                 |'
'|--------------------------------------------------------------------------|'
'| Produces an error message                                                |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

SELECT CASE UCASE$(APIerr$)
'---------------------------------------- Error List Starts
'-------------------------------+ User Termination
CASE "USER"
E$ = "User Termination"
'-------------------------------+ Other Error
CASE ELSE
E$ = APIerr$
'---------------------------------------- Error List Ends
END SELECT
SCREEN 0
WIDTH 40
COLOR 2, 1
PRINT " Amethyst V1.08                  ";
IF showerror = 1 THEN PRINT "Error! ";
IF showerror = 0 THEN PRINT "       ";
COLOR 4, 0
PRINT : PRINT
IF showerror = 1 THEN PRINT "ERROR! ";
COLOR 15, 0
IF showerror = 1 THEN PRINT "- ";
PRINT E$
IF critical = 1 THEN END
SLEEP 0
AMsystem.forcerefresh = 1
SCREEN screenmode
refresh
END SUB

SUB APImousecursor (a$)

'|--------------------------------------------------------------------------|'
'| APImousecusror (Cursor$)                                                 |'
'|--------------------------------------------------------------------------|'
'| Changes the mouse cursor. A$ is either a built in cursor, or a filename. |'
'|                                                                          |'
'| I am in the process of updating to support Animated Cursors              |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

IF a$ = "" THEN EXIT SUB
SELECT CASE RIGHT$(a$, 3)
CASE "cur"
AMsystem.cursormode = "STATIC"
anm = 0
CASE "anc"
AMsystem.cursormode = "ANIMATED"
anm = 1
END SELECT
IF anm = 1 THEN GOTO llllyyyy:
DIM Regs AS RegType
SELECT CASE a$
CASE "BADHOURGLASS"
RESTORE TIMERcursor:
CASE "ARROW"
RESTORE ARROWcursor:
CASE ELSE
OPEN amethystpath$ + "system\cursors\" + a$ FOR BINARY AS #1
IF LOF(1) <> 64 THEN
CLOSE #1
RESTORE ARROWcursor:
GOTO oopsitsgone
END IF
cur$ = SPACE$(64)
GET #1, , cur$: CLOSE #1
Regs.ax = 9: Regs.bx = Hotx: Regs.cx = Hoty
Regs.dx = SADD(cur$)
CALL INTERRUPT(&H33, Regs, Regs)
EXIT SUB
END SELECT
oopsitsgone:
FOR I% = 1 TO 32
READ wrd%
MMsk$ = MMsk$ + MKI$(wrd%)
NEXT I%
READ Hotx, Hoty
Regs.ax = 9: Regs.bx = Hotx: Regs.cx = Hoty
Regs.dx = SADD(MMsk$)
CALL INTERRUPT(&H33, Regs, Regs)
EXIT SUB
llllyyyy:
OPEN amethystpath$ + "cursors\" + a$ FOR BINARY AS #1
IF LOF(1) <> 526 THEN
CLOSE #1
RESTORE ARROWcursor:
GOTO oopsitsgone
END IF
COLOR 15
cur$ = SPACE$(526)
GET #1, , cur$: CLOSE #1
FOR n = 1 TO 8
anmcur$(n) = LEFT$(cur$, 64)
NEXT
AMsystem.anmcurtimer = 1
END SUB

SUB APIscreensaver
END SUB

FUNCTION APIstackspace

'|--------------------------------------------------------------------------|'
'| APIstackspace                                                            |'
'|--------------------------------------------------------------------------|'
'| Returns the amount of free stack space in bytes                          |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

APIstackspace = FRE(-2)
END FUNCTION

FUNCTION APIstringspace

'|--------------------------------------------------------------------------|'
'| APIstringspace                                                           |'
'|--------------------------------------------------------------------------|'
'| Returns the amount of free string space in bytes                         |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

APIstringspace = FRE(0)
END FUNCTION

SUB APIswapvalue (a%, B%)

'|--------------------------------------------------------------------------|'
'| APIswapvalue (A, B)                                                      |'
'|--------------------------------------------------------------------------|'
'| Swaps the values in A and B                                              |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

c% = a%
a% = B%
B% = c%
END SUB

SUB APItextarea (t$, x, y, xx, yy)

'|--------------------------------------------------------------------------|'
'| APItextarea (text$, x, y, xx, yy)                                        |'
'|--------------------------------------------------------------------------|'
'| Centers the string T$ within the window of specified by x, y, xx and yy  |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

IF xx - x > yy - y THEN dirmode = 1
IF yy - y > xx - x THEN dirmode = 0
IF dirmode = 1 THEN text t$, (xx - x) / 2 - (APItextwidth(t$) / 2) + x + 1, ((yy - y) / 2 - 4) + y, 15
END SUB

FUNCTION APItextwidth (t$)

'|--------------------------------------------------------------------------|'
'| APItextwidth                                                             |'
'|--------------------------------------------------------------------------|'
'| Returns the length of a string in pixels                                 |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

t$ = trim$(t$)
APItextwidth = LEN(t$) * 8
END FUNCTION

SUB APIwaitforretrace

'|--------------------------------------------------------------------------|'
'| APIwaitforretrace                                                        |'
'|--------------------------------------------------------------------------|'
'| Waits until monitor starts it's next vertical retrace                    |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

WAIT &H3DA, 8
END SUB

SUB APIwraptext (t$, x, y, xx, yy, c)

'|--------------------------------------------------------------------------|'
'| APIwraptext (Text$, x, y, xx, yy, color)                                 |'
'|--------------------------------------------------------------------------|'
'|==========================================================================|'
'| UNDER CONSTRUCTION  UNDER CONSTRUCTION  UNDER CONSTRUCTION  UNDER CONSTR |
'|==========================================================================|'
'| Like APItextarea, but allows wrapping.                                   |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

t$ = t$ + " "
DIM line$(25)
curline = 1
FOR n = 1 TO LEN(t$)
a$ = MID$(t$, n, 1)
SELECT CASE a$
CASE IS <> " "
tmp$ = tmp$ + a$
CASE " "
IF APItextwidth(tmp$) + APItextwidth(line$(curline)) <= xx - x THEN line$(curline) = line$(curline) + " " + tmp$: tmp$ = ""
IF APItextwidth(tmp$) + APItextwidth(line$(curline)) > xx - x THEN curline = curline + 1: line$(curline) = line$(curline) + " " + tmp$: tmp$ = ""
END SELECT
NEXT
FOR n = 1 TO 25
IF line$(n) > "" THEN text line$(n), x, y + ((n - 1) * 8), c
NEXT
END SUB

SUB bevel (x, y, xx, yy, inout)

'|--------------------------------------------------------------------------|'
'| bevel (x, y, xx, yy, height)                                             |'
'|--------------------------------------------------------------------------|'
'| Draws a bevel using co-ordinates x, y, xx, yy.                           |'
'| Inout can be -2, -1, 0, 1 or 2                                           |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

H = 999
HH = 999
s = 999
SS = 999
SELECT CASE inout
CASE 2
HH = col3dHH
H = col3dH
SS = col3dSS
s = col3dS
CASE 1
HH = col3dH
SS = col3dSS
CASE 0
SS = coltext
HH = coltext
CASE -1
SS = 15
HH = 0
CASE -2
s = 15
SS = 15
H = 0
HH = 0
END SELECT
IF HH <> 999 THEN
LINE (x, y)-(xx, y), HH
LINE (x, y)-(x, yy), HH
END IF
IF SS <> 999 THEN
LINE (xx, yy)-(xx, y), SS
LINE (xx, yy)-(x, yy), SS
END IF
IF H <> 999 THEN
LINE (x + 1, y + 1)-(xx - 1, y + 1), H
LINE (x + 1, y + 1)-(x + 1, yy - 1), H
END IF
IF s <> 999 THEN
LINE (xx - 1, yy - 1)-(xx - 1, y + 1), s
LINE (xx - 1, yy - 1)-(x + 1, yy - 1), s
END IF
IF H = 999 AND s = 999 THEN
PSET (xx, y), col3dmerge
PSET (x, yy), col3dmerge
END IF
'PSET (xx - 1, y + 1), col3dmerge
'PSET (x + 1, yy - 1), col3dmerge
END SUB

SUB CreateForm (num, x, y, xx, yy, title$, style$, makeactive, mkvisible)
IF mkvisible = true THEN form(num).visible = 1
form(num).x = x
form(num).y = y
form(num).xx = xx
form(num).yy = yy
form(num).title$ = title$
form(num).style$ = style$
IF makeactive = true THEN reorder (num)
END SUB

SUB CreateIcon (num, frm, x, y, fl$, ix, vis)
icon(num).form = frm
icon(num).x = x
icon(num).y = y
icon(num).file$ = fl$
icon(num).index = ix
IF vis = true THEN icon(num).visible = 1
END SUB

SUB CreateLabel (num, frm, x, y, xx, yy, txt$, c, visible)
label(num).x = x
label(num).y = y
label(num).xx = xx
label(num).yy = yy
label(num).text$ = txt$
label(num).colour = c
label(num).form = frm
IF visible = true THEN label(num).visible = 1
END SUB

SUB CreateLight (num, frm, x, y, xx, yy, vis)
IF vis = true THEN Light(num).visible = 1
Light(num).form = frm
Light(num).x = x
Light(num).y = y
Light(num).xx = xx
Light(num).yy = yy
Light(num).onoff = 0
END SUB

SUB CreateProgress (num, frm, x, y, xx, yy, max, visible)
Progress(num).form = frm
Progress(num).x = x
Progress(num).y = y
Progress(num).xx = xx
Progress(num).yy = yy
IF visible = true THEN Progress(num).visible = 1
Progress(num).max = max
END SUB

SUB desktop

'|--------------------------------------------------------------------------|'
'| desktop                                                                  |'
'|--------------------------------------------------------------------------|'
'| Draws the wallpaper                                                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

LINE (0, 0)-(screenxres, screenyres), coldesktop, BF
dotback styledotback
END SUB

SUB dotback (st)

'|--------------------------------------------------------------------------|'
'| dotback (style)                                                          |'
'|--------------------------------------------------------------------------|'
'| Draws a pattern on the background                                        |'
'| The pattern depends on st
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

screendivid = screendivide
FOR a = 95 / 2 TO 1820 / 2 STEP 45 / 2
row = a / 40 + 1
COL = a MOD 40 + 1
COL = COL * screendesktopintensity
row = row * screendesktopintensity
SELECT CASE st
CASE 1
PSET (COL * 8, row * 8), coldesktoptext
CASE 2
text CHR$(1), COL * 8, row * 8, coldesktoptext
CASE 4
CIRCLE (COL * 8, row * 8), INT(RND * 6) + 1, coldesktoptext
END SELECT
NEXT
END SUB

SUB DrawButton (num)

'|--------------------------------------------------------------------------|'
'| DrawButton (index)                                                       |'
'|--------------------------------------------------------------------------|'
'| Draws the button indicated by index                                      |'
'|                                                                          |'
'| Uses QuickReference (tm) technology                                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

SELECT CASE trim$(form(button(num).form).style)
CASE "_"
tbh = tbheight
LINE ((button(num).x + form(button(num).form).x), (button(num).y) + tbh + form(button(num).form).y)-((button(num).xx + form(button(num).form).x), (button(num).yy + form(button(num).form).y + tbh)), col3d, BF
bevel button(num).x + form(button(num).form).x, tbh + button(num).y + form(button(num).form).y, button(num).xx + form(button(num).form).x, button(num).yy + form(button(num).form).y + tbh, 1
APItextarea button(num).caption$, button(num).x + form(button(num).form).x, tbh + button(num).y + form(button(num).form).y, button(num).xx + form(button(num).form).x, button(num).yy + form(button(num).form).y + tbh
CASE "Linux"
PRINT "Not Yet!"
CASE "Mac"
tbh = 25
LINE ((button(num).x + form(button(num).form).x), (button(num).y) + tbh + form(button(num).form).y)-((button(num).xx + form(button(num).form).x), (button(num).yy + form(button(num).form).y + tbh)), col3d, BF
bevel button(num).x + form(button(num).form).x, tbh + button(num).y + form(button(num).form).y, button(num).xx + form(button(num).form).x, button(num).yy + form(button(num).form).y + tbh, 2
APItextarea button(num).caption$, button(num).x + form(button(num).form).x, tbh + button(num).y + form(button(num).form).y, button(num).xx + form(button(num).form).x, button(num).yy + form(button(num).form).y + tbh
END SELECT
END SUB

SUB DrawForm (num)

'|--------------------------------------------------------------------------|'
'| DrawForm (index)                                                         |'
'|--------------------------------------------------------------------------|'
'| Draws the form indicated by index                                        |'
'|                                                                          |'
'| Uses QuickReference (tm) technology                                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

AMmousehide
IF winorder(0) = num THEN active = 1
tbcol = coltbinactive
IF active = 1 THEN tbcol = coltbactive
a$ = form(num).style
SELECT CASE trim$(a$)
CASE "_"
xyform (form(num).x), (form(num).y), (form(num).xx), (form(num).yy), form(num).title, active
CASE "Win16"
COL = form(num).x
row = form(num).y
length = form(num).xx - form(num).x
Height = form(num).yy - form(num).y
title$ = form(num).title
LINE (COL, row)-(COL + length, row + Height), colwin16border, B
FOR I% = 1 TO 2
row = row + 1: COL = COL + 1: Height = Height - 1: length = length - 1
LINE (COL, row)-(COL + length, row), col3d
LINE (COL, row)-(COL, row + Height), col3d
NEXT I%
row = row + 1: COL = COL + 1: Height = Height - 1: length = length - 1
LINE (COL, row)-(COL + length, row), colwin16border
LINE (COL, row)-(COL, row + Height), colwin16border
LINE (COL, row)-(COL + 18, row + 18), col3d, BF
LINE (COL, row)-(COL + 18, row + 18), colwin16border, B
LINE (COL + 18, row - 2)-(COL + 18, row + 5), colwin16border
LINE (COL - 2, row + 18)-(COL + 5, row + 18), colwin16border
LINE (COL + 5, row + 7)-(COL + 13, row + 9), 15, BF: LINE (COL + 5, row + 7)-(COL + 13, row + 9), 0, B
LINE (COL + 14, row + 7)-(COL + 14, row + 9), 8
LINE (COL + 6, row + 10)-(COL + 14, row + 10), 8, B
LINE (COL + 18, row)-(COL + length, row + 18), tbcol, BF
LINE (COL + 18, row)-(COL + length, row + 18), colwin16border, B
LINE (COL + length, row - 3)-(COL + length + 2, row + Height), col3d, BF
LINE (COL + length, row - 3)-(COL + length + 3, row + Height), colwin16border, B
LINE (COL + length, row - 2)-(COL + length, row - 1), col3d
LINE (COL + length - 18, row - 2)-(COL + length - 18, row - 1), colwin16border
LINE (COL + length, row + 18)-(COL + length + 2, row + 18), col3d
LINE (COL, row + Height - 3)-(COL + length, row + Height - 3), colwin16border, B
LINE (COL, row + Height - 2)-(COL + length + 2, row + Height), col3d, BF
LINE (COL - 2, row + Height)-(COL + length + 2, row + Height), colwin16border, B
LINE (COL - 2, row + Height - 18)-(COL, row + Height - 18), colwin16border
LINE (COL + length - 2, row + Height - 18)-(COL + length + 2, row + Height - 18), colwin16border
LINE (COL + 18, row + Height)-(COL + 18, row + Height - 2), colwin16border
LINE (COL + length - 18, row + Height)-(COL + length - 18, row + Height - 2), colwin16border
LINE (COL + 1, row + 19)-(COL + length - 1, row + Height - 4), col3d, BF
SELECT CASE systemtbtextalign
CASE 1
text trim$(title$), COL + 5, row + 5, coltbtext
CASE 3
text trim$(title$), COL + length - 5 - APItextwidth(title$), row + 5, coltbtext
CASE 2
APItextarea trim(title$), COL, row + 3, COL + length, row + 15
END SELECT
CASE "OS/2"
PRINT "OS/2 Style not yet available"
CASE "FVWM#1"
PRINT "FVWM Style not yet available"
CASE "FVWN#2"
PRINT "FVWM 2 Style not yet available"
CASE "FVWM#95"
PRINT "FVWM 95 Style not yet available"
CASE "Madden"
PRINT "You must be MADden!"
CASE "Win32"
PRINT "Windows 95 Style not yet available"
CASE "Win163D"
title$ = form(num).title
LINE (form(num).x, form(num).y)-(form(num).xx, form(num).yy), 8, BF
LINE (form(num).x + 1, form(num).y + 1)-(form(num).xx - 1, form(num).yy - 1), 7, BF
LINE (form(num).x, form(num).y)-(form(num).x, form(num).yy), 15
LINE (form(num).x, form(num).y)-(form(num).xx, form(num).y), 15
LINE (form(num).x + 3, form(num).y + 3)-(form(num).xx - 3, form(num).y + 20), tbcol, BF
LINE (form(num).xx - 21, form(num).y + 4)-(form(num).xx - 5, form(num).y + 18), 0, B
LINE (form(num).xx - 21, form(num).y + 4)-(form(num).xx - 5, form(num).y + 18), 0, B
LINE (form(num).xx - 19, form(num).y + 6)-(form(num).xx - 7, form(num).y + 16), 7, BF
PSET (form(num).xx - 20, form(num).y + 5), 15
DRAW "r14d1c8d11l14c15u12 br4bd3c8r1d1r1d1r3u1r1u1r1l1d1l1d1l1d2r1d1r1d1r1l1u1l1u1l2u1d1l1d1l1d1l1r1d1c15r1u1r1u1be2r1u1r1u1bd6r1u1"
LINE (form(num).x + 3, form(num).y + 3)-(form(num).xx - 3, form(num).y + 20), 15, B
LINE (form(num).x + 3, form(num).y + 3)-(form(num).xx - 3, form(num).y + 3), 8
LINE (form(num).x + 3, form(num).y + 3)-(form(num).x + 3, form(num).y + 20), 8
SELECT CASE systemtbtextalign
CASE 1
text trim$(title$), form(num).x + 5, form(num).y + 5, coltbtext
CASE 3
text trim$(title$), form(num).xx - 5 - APItextwidth(title$), form(num).y + 5, coltbtext
CASE 2
APItextarea trim(title$), (form(num).x), form(num).y + 3, (form(num).xx), form(num).y + 20
END SELECT
CASE "Linux"
LINE (form(num).x, form(num).y)-(form(num).xx, form(num).yy), 3, B
LINE (form(num).x + 1, form(num).y + 1)-(form(num).xx - 1, form(num).yy - 1), 3, B
LINE (form(num).x + 2, form(num).y + 2)-(form(num).xx - 2, form(num).y + 20), 3, BF
LINE (form(num).x + 2, form(num).y + 2)-(form(num).xx - 2, form(num).y + 20), 8, B
LINE (form(num).x + 2, form(num).y + 21)-(form(num).xx - 2, form(num).yy - 2), COL, BF
LINE (form(num).xx - 20, form(num).y + 3)-(form(num).xx - 20, form(num).y + 20), 7, B
LINE (form(num).xx - 21, form(num).y + 3)-(form(num).xx - 21, form(num).y + 20), 8, B
LINE (form(num).xx - 40, form(num).y + 3)-(form(num).xx - 40, form(num).y + 20), 7, B
LINE (form(num).xx - 41, form(num).y + 3)-(form(num).xx - 41, form(num).y + 20), 8, B
LINE (form(num).x + 20, form(num).y + 3)-(form(num).x + 20, form(num).y + 20), 8, B
LINE (form(num).x + 21, form(num).y + 3)-(form(num).x + 21, form(num).y + 20), 7, B
LINE (form(num).x + 2, form(num).y + 3)-(form(num).x + 2, form(num).yy - 2), 8, B
LINE (form(num).xx - 2, form(num).y + 3)-(form(num).xx - 2, form(num).yy - 2), 8, B
LINE (form(num).x + 2, form(num).yy - 2)-(form(num).xx - 2, form(num).yy - 2), 8, B
APItextarea form(num).title$, (form(num).x) + 15, (form(num).y), (form(num).xx) - 32, (form(num).y) + 22
LINE (form(num).x + 7, form(num).y + 9)-(form(num).x + 16, form(num).y + 12), 15, B
LINE (form(num).x + 7, form(num).y + 12)-(form(num).x + 16, form(num).y + 12), 8, B
LINE (form(num).x + 16, form(num).y + 9)-(form(num).x + 16, form(num).y + 12), 8, B
LINE (form(num).xx - 15, form(num).y + 7)-(form(num).xx - 6, form(num).y + 15), 15, B
LINE (form(num).xx - 15, form(num).y + 15)-(form(num).xx - 6, form(num).y + 15), 8, B
LINE (form(num).xx - 6, form(num).y + 7)-(form(num).xx - 6, form(num).y + 15), 8, B
LINE (form(num).xx - 31, form(num).y + 10)-(form(num).xx - 29, form(num).y + 12), 15, B
LINE (form(num).xx - 31, form(num).y + 12)-(form(num).xx - 29, form(num).y + 12), 8, B
LINE (form(num).xx - 29, form(num).y + 10)-(form(num).xx - 29, form(num).y + 12), 8, B
CASE "Mac"
LINE (form(num).x, form(num).y)-(form(num).xx, form(num).yy), 8, B
LINE (form(num).x + 1, form(num).y + 1)-(form(num).xx, form(num).y + 20), 15, BF
LINE (form(num).x + 1, form(num).y + 20)-(form(num).xx, form(num).yy - 1), 7, BF
LINE (form(num).x + 2, form(num).y + 20)-(form(num).xx - 2, form(num).y + 20), 7, B
LINE (form(num).x + 2, form(num).y + 21)-(form(num).xx - 2, form(num).y + 21), 8, B
LINE (form(num).x + 2, form(num).y + 22)-(form(num).xx - 2, form(num).y + 22), 0, B
LINE (form(num).x, form(num).y)-(form(num).xx, form(num).yy), 8, B
FOR I = 1 TO 14 STEP 3
LINE (form(num).x + 3, form(num).y + 3 + I)-(form(num).xx - 3, form(num).y + 3 + I), 7
LINE (form(num).x + 3, form(num).y + 4 + I)-(form(num).xx - 3, form(num).y + 4 + I), 8
NEXT I
LINE (form(num).x + 12, form(num).y + 4)-(form(num).x + 26, form(num).y + 17), 8, BF
LINE (form(num).x + 14, form(num).y + 6)-(form(num).x + 26, form(num).y + 17), 15, BF
LINE (form(num).x + 15, form(num).y + 7)-(form(num).x + 24, form(num).y + 16), 0, BF
LINE (form(num).x + 15, form(num).y + 7)-(form(num).x + 22, form(num).y + 14), 7, BF
length = APItextwidth(form(num).title$)
LINE ((form(num).xx - form(num).x) / 2 + form(num).x - (length / 2) - 5, form(num).y + 4)-((form(num).xx - form(num).x) / 2 + form(num).x + (length / 2) + 5, form(num).y + 19), 15, BF
text form(num).title$, (form(num).xx - form(num).x) / 2 - (APItextwidth(form(num).title$) / 2) + form(num).x + 1, (((form(num).y + 23) - form(num).y) / 2 - 4) + form(num).y, 0
LINE (form(num).x + 2, form(num).y + 23)-(form(num).x + 2, form(num).yy - 2), 8, B
LINE (form(num).xx - 2, form(num).y + 23)-(form(num).xx - 2, form(num).yy - 2), 8, B
LINE (form(num).x + 2, form(num).yy - 2)-(form(num).xx - 2, form(num).yy - 2), 8, B
CASE "Striped"
x = form(num).x
y = form(num).y
xx = form(num).xx
yy = form(num).yy
LINE (x, y)-(xx, yy), 0, BF
LINE (x, y)-(xx, y), 15
LINE (x + 1, y + 1)-(xx - 1, y + 1), 7
LINE (x + 2, y + 2)-(xx - 2, y + 2), 8
LINE (x + 5, y)-(xx - 5, y), 14
LINE (x + 5, y + 5)-(xx - 5, y + 5), 14
LINE (x, yy)-(xx, yy), 15
LINE (x + 1, yy - 1)-(xx - 1, yy - 1), 7
LINE (x + 2, yy - 2)-(xx - 2, yy - 2), 8
LINE (x + 5, yy)-(xx - 5, yy), 14
LINE (x + 5, yy - 5)-(xx - 5, yy - 5), 14
LINE (x, y)-(x, yy), 15
LINE (x + 1, y + 1)-(x + 1, yy - 1), 7
LINE (x + 2, y + 2)-(x + 2, yy - 2), 8
LINE (x + 5, y + 5)-(x + 5, yy - 5), 14
LINE (xx, y)-(xx, yy), 15
LINE (xx - 1, y + 1)-(xx - 1, yy - 1), 7
LINE (xx - 2, y + 2)-(xx - 2, yy - 2), 8
LINE (xx - 5, y + 5)-(xx - 5, yy - 5), 14
FOR I = x + 5 TO xx - 15 STEP 10
CIRCLE (I, y + 1), 4, 14, 5.5
CIRCLE (I, yy - 4), 4, 14, 5.5
NEXT I
FOR I = y + 6 TO yy - 10 STEP 10
CIRCLE (x - 5, I), 9, 14, 5.5
CIRCLE (xx - 10, I), 9, 14, 5.5
NEXT I
LINE (x + 7, y + 8)-(xx - 7, yy - 8), 7, B
LINE (x + 8, y + 21)-(xx - 8, y + 21), 15
LINE (x + 8, y + 22)-(xx - 8, y + 22), 7
text form(num).title$, x + 10, y + 11, 15
LINE (xx - 20, y + 8)-(xx - 20, y + 20), 7
LINE (xx - 19, y + 9)-(xx - 19, y + 20), 8
CIRCLE (xx - 13, y + 14), 4, 15
CIRCLE (xx - 13, y + 14), 3, 7
CIRCLE (xx - 13, y + 14), 2, 8
CASE "Text"
x = form(num).x / 8
y = form(num).y / 16
xx = form(num).xx / 8
yy = form(num).yy / 16
title$ = form(num).title
COLOR col3d
FOR I = y TO yy
LOCATE I, x: PRINT APIcharstring$("", xx - x + 1);
NEXT I
IF title$ <> "" THEN
LOCATE y, x: COLOR tbcol: PRINT APIcharstring$("", xx - x + 1);
fw = (form(num).xx - form(num).x + 1)
text trim$(title$), form(num).x + ((fw - APItextwidth(trim$(title$))) \ 2) - 8, (form(num).y) - 16 + 4, coltbtext
END IF
CASE ELSE
xyformcustom a$
END SELECT
FOR n = 1 TO maxlabels
IF label(n).form = num AND label(n).visible = 1 THEN DrawLabel (n)
NEXT
FOR n = 1 TO maxprogress
IF Progress(n).form = num AND Progress(n).visible = 1 THEN DrawProgress (n)
NEXT
FOR n = 1 TO maxlights
IF Light(n).form = num THEN DrawLight (n)
NEXT
FOR n = 1 TO maxicons
IF icon(n).form = num THEN DrawIcon (n)
NEXT
FOR n = 1 TO maxbuttons
IF button(n).form = num THEN DrawButton (n)
NEXT
END SUB

SUB DrawIcon (num)

'|--------------------------------------------------------------------------|'
'| DrawIcon (index)                                                         |'
'|--------------------------------------------------------------------------|'
'| Draws the icon indicated by index                                        |'
'|                                                                          |'
'| Uses QuickReference (tm) technology                                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

SELECT CASE UCASE$(RIGHT$(trim$(icon(num).file), 3))
CASE "GFX"
DIM TMPicon(1 TO 4 + INT(((36 - 0 + 1) * (1) + 7) / 8) * 4 * ((36 - 0) + 1))
DEF SEG = VARSEG(TMPicon(1))
BLOAD trim$(icon(num).file), VARPTR(TMPicon(1))
DEF SEG
PUT (icon(num).x + form(icon(num).form).x, icon(num).y + form(icon(num).form).y + tbheight), TMPicon(1), PSET
CASE "ICO"
nmb = icon(num).index
fx = form(icon(num).form).x + icon(num).x
fy = form(icon(num).form).y + GetTBSize(num) + icon(num).y
bevel fx - 1, fy - 1, fx + 32, fy + 32, -1
'/* Icon File Main Header */'
Reserv1$ = SPACE$(2): Valid$ = SPACE$(2): NoOfIcons$ = SPACE$(2)

'/* Icon Main Header */'
PixelWidth$ = SPACE$(1): PixelHeight$ = SPACE$(1): NoOfColors$ = SPACE$(1)
Reserv2$ = SPACE$(1): Planes$ = SPACE$(2): BitCount$ = SPACE$(2)
TotalBytesOfImage$ = SPACE$(4): LocationOfImage$ = SPACE$(4)

'/* Icon Minor Header (BMP Info Header) */'
SizeOfHeader$ = SPACE$(4): Width$ = SPACE$(4): Height$ = SPACE$(4)
Plane$ = SPACE$(2): BitsPerPixel$ = SPACE$(2): Compressed$ = SPACE$(4)
SizeOfImage$ = SPACE$(4): XMeter$ = SPACE$(4): YMeter$ = SPACE$(4)
ClrUsed$ = SPACE$(4): ClrImportant$ = SPACE$(4)
filename$ = trim$(icon(num).file)
OPEN filename$ FOR BINARY AS #255
IF LOF(255) = 0 THEN
   CLOSE #255
   KILL filename$
END IF
                         GET #255, , Reserv1$
GET #255, , Valid$
GET #255, , NoOfIcons$
IF CVI(Reserv1$) = 19778 THEN
   Location$ = SPACE$(4)
   GET #255, 11, Location$
   SEEK #255, 15
   GOSUB ReadIcon
ELSE
   
   FOR IconNumber = 1 TO nmb
      
      '/* Extract Icon File Minor Header */'
      GET #255, , PixelWidth$
      GET #255, , PixelHeight$
      GET #255, , NoOfColors$
      GET #255, , Reserv2$
      GET #255, , Planes$
      GET #255, , BitCount$
      GET #255, , TotalBytesOfImage$
      GET #255, , LocationOfImage$
      Location& = LOC(255) + 1
      SEEK #255, CVL(LocationOfImage$) + 1
      GOSUB ReadIcon
      SEEK #255, Location&
   NEXT IconNumber
END IF


ReadIcon:
'/* Extract Icon Minor Header */'
   GET #255, , SizeOfHeader$
   GET #255, , Width$
   GET #255, , Height$
   GET #255, , Plane$
   GET #255, , BitsPerPixel$
   GET #255, , Compressed$
   GET #255, , SizeOfImage$
   GET #255, , XMeter$
   GET #255, , YMeter$
   GET #255, , ClrUsed$
   GET #255, , ClrImportant$

   IF CVI(BitsPerPixel$) = 1 THEN

      AMsystem.message$ = " Can not Load 1-bit Images "
      RETURN
   ELSEIF CVI(Compressed$) <> 0 THEN

      AMsystem.message$ = " Can not Load Compressed Images"
      RETURN
   END IF

   PixelWidth = CVL(Width$): PixelHeight = CVL(Height$)
   NumberOfColors& = 2 ^ CVI(BitsPerPixel$): PaletteBlue$ = SPACE$(1)
   PaletteGreen$ = SPACE$(1): PaletteRed$ = SPACE$(1): Empty$ = SPACE$(1)


IF CVI(BitsPerPixel$) < 9 THEN
      FOR Loops = 0 TO NumberOfColors& - 1
         '/* Extract the palette of each of the colors and change the palette */'
         GET #255, , PaletteBlue$
         GET #255, , PaletteGreen$
         GET #255, , PaletteRed$
         GET #255, , Empty$                        ' Pointless!
'         OUT &H3C8, Loops
'         OUT &H3C9, ASC(PaletteRed$) \ 4
'         OUT &H3C9, ASC(PaletteGreen$) \ 4
'         OUT &H3C9, ASC(PaletteBlue$) \ 4
      NEXT Loops
   END IF
   
   IF CVI(Reserv1$) = 0 THEN PixelHeight = PixelHeight \ 2

   IF CVI(BitsPerPixel$) = 4 THEN
      LineExtract$ = SPACE$(PixelWidth \ 2)
      IF (4 - CINT((PixelWidth MOD 8) / 2)) <> 4 THEN
         LineExtract$ = LineExtract$ + SPACE$(4 - CINT((PixelWidth MOD 8) / 2))
      END IF
      FOR y = PixelHeight - 1 TO 0 STEP -1
         GET #255, , LineExtract$
         FOR x = 0 TO PixelWidth - 1 STEP 2
            PSET (x + fx, y + fy), ASC(MID$(LineExtract$, INT((x / 2)) + 1, 1)) \ 16
            PSET (x + fx + 1, y + fy), ASC(MID$(LineExtract$, INT((x / 2)) + 1, 1)) AND 15
         NEXT x
      NEXT y
   ELSEIF CVI(BitsPerPixel$) = 8 THEN
      LineExtract$ = SPACE$(PixelWidth)
      IF CVI(Reserv1$) <> 0 THEN SEEK #255, CVL(Location$) + 1
      IF (4 - (PixelWidth MOD 4)) <> 4 THEN Extra$ = SPACE$(4 - (PixelWidth MOD 4))
      FOR y = PixelHeight - 1 TO 0 STEP -1
         GET #255, , LineExtract$
         GET #255, , Extra$
         FOR x = 0 TO PixelWidth - 1
            PSET (x + fx, y + fy), ASC(MID$(LineExtract$, x + 1, 1))
         NEXT x
      NEXT y
   ELSEIF CVI(BitsPerPixel$) = 24 THEN
      IF CVI(Reserv1$) <> 0 THEN SEEK #255, CVL(Location$) + 1
      FOR Loops = 0 TO 255
         OUT &H3C8, Loops
         OUT &H3C9, Loops \ 4
         OUT &H3C9, Loops \ 4
         OUT &H3C9, Loops \ 4
      NEXT Loops
      LineExtract$ = SPACE$(PixelWidth * 3)
      IF (4 - ((PixelWidth * 3) MOD 4)) <> 4 THEN
         LineExtract$ = SPACE$((PixelWidth * 3) + (4 - ((PixelWidth * 3) MOD 4)))
      END IF
      FOR y = PixelHeight - 1 TO 0 STEP -1
         GET #255, , LineExtract$
         FOR x = 0 TO PixelWidth - 1
            PaletteBlue$ = MID$(LineExtract$, x * 3 + 1, 1)
            PSET (x + fx, y + fy), ASC(PaletteBlue$)
         NEXT x
      NEXT y
   END IF
RETURN
CASE "ICN"
END SELECT
END SUB

SUB DrawLabel (num)

'|--------------------------------------------------------------------------|'
'| DrawLabel (index)                                                        |'
'|--------------------------------------------------------------------------|'
'| Draws the label indicated by index                                       |'
'|                                                                          |'
'| Uses QuickReference (tm) technology                                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

fx = form(label(num).form).x
fy = form(label(num).form).y + tbheight
APIwraptext trim$(label(num).text), (label(num).x) + fx, (label(num).y) + fy, (label(num).xx) + fx, (label(num).yy) + fy, (label(num).colour)
END SUB

SUB DrawLight (num)

'|--------------------------------------------------------------------------|'
'| DrawLight (index)                                                        |'
'|--------------------------------------------------------------------------|'
'| Draws the light indicated by index                                       |'
'|                                                                          |'
'| Uses QuickReference (tm) technology                                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

fx = form(Light(num).form).x
fy = form(Light(num).form).y + tbheight
x = Light(num).x
y = Light(num).y
xx = Light(num).xx
yy = Light(num).yy
onoff = Light(num).onoff
IF onoff <> Light(num).lastonoff OR AMsystem.forcerefresh = 1 THEN
AMmousehide
LINE (x + fx, y + fy)-(xx + fx, yy + fy), col3d, BF
IF onoff = 1 THEN LINE (x + fx, y + fy)-(xx + fx, yy + fy), coltb, BF
bevel x + fx, y + fy, xx + fx, yy + fy, -1
Light(num).lastonoff = onoff
AMmouseshow
END IF
END SUB

SUB DrawProgress (num)

'|--------------------------------------------------------------------------|'
'| DrawProgress (index)                                                     |'
'|--------------------------------------------------------------------------|'
'| Draws the progress bar indicated by index                                |'
'|                                                                          |'
'| Uses QuickReference (tm) technology                                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

fx = form(Progress(num).form).x
fy = form(Progress(num).form).y + tbheight
cur = Progress(num).cur
IF cur <> Progress(num).lastcur OR AMsystem.forcerefresh = 1 THEN
max = Progress(num).max
x = Progress(num).x
y = Progress(num).y
xx = Progress(num).xx
yy = Progress(num).yy
percent = (cur / max) * 100
bar = (xx - x - 2) / 100 * percent
IF cur > max THEN EXIT SUB
IF AMmousex > x + fx - 16 AND AMmousex < xx + fx AND AMmousey > y + fy - 16 AND AMmousey < yy + fy THEN AMmousehide
APIwaitforretrace
LINE (x + fx, y + fy)-(xx + fx, yy + fy), col3d, BF
bevel x + fx, y + fy, xx + fx, yy + fy, -1
LINE (x + fx + 1, y + fy + 1)-(x + fx + bar + 1, yy + fy - 1), 1, BF
APItextarea trim$(STR$(INT(percent))) + "%", x + fx, (Progress(num).y) + fy, (Progress(num).xx) + fx, (Progress(num).yy) + fy
Progress(num).lastcur = cur
AMmouseshow
END IF
END SUB

SUB ExternalFont (t$, x%, y%, horzsize%, vertsize%, style%, colr%)

'|--------------------------------------------------------------------------|'
'| ExternalFont (Txt$, x, y, Horizontal Scale, Vertical Scale, Style, color)|'
'|--------------------------------------------------------------------------|'
'| Used by some of the styles I extracted from other programs.              |'
'|                                                                          |'
'| Unknown Author                                                           |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

DEF SEG = &HF000
bits$ = CHR$(128) + CHR$(64) + CHR$(32) + CHR$(16) + CHR$(8) + CHR$(4) + CHR$(2) + CHR$(1)
slen = LEN(t$)
FOR y = 0 TO 7
a$ = ""
FOR ct = 1 TO slen
byte = PEEK(&HFA6E + ASC(MID$(t$, ct, 1)) * 8 + y)
FOR x = 1 TO 8
IF byte AND ASC(MID$(bits$, x, 1)) THEN
xpixel% = x% + (x - 1) * horzsize% + (ct - 1) * 8 * horzsize%
ypixel% = y% + y * vertsize%
SELECT CASE style%
CASE 0
LINE (xpixel%, ypixel%)-(xpixel% + horzsize% - 1, ypixel% + vertsize% - 1), colr%, BF
CASE 1
LINE (xpixel%, ypixel%)-(xpixel% + horzsize% - 1, ypixel% + vertsize% - 1), colr%, B
CASE 2
LINE (xpixel%, ypixel%)-(xpixel% + horzsize% - 1, ypixel% + vertsize% - 1), colr%
CASE 3
LINE (xpixel% + horzsize% - 1, ypixel%)-(xpixel%, ypixel% + vertsize% - 1), colr%
CASE 4
PSET (xpixel%, ypixel%), colr%
CASE 5
LINE (xpixel% + horzsize% - 1, ypixel%)-(xpixel% + 1, ypixel% + vertsize% - 1), colr%
CASE 6
LINE (xpixel% - 1, ypixel%)-(xpixel% + horzsize% - 1, ypixel% + vertsize% - 1), colr%, B
CASE 1

END SELECT

END IF
NEXT
NEXT
NEXT
END SUB

SUB forminfo

'|--------------------------------------------------------------------------|'
'| forminfo                                                                 |'
'|--------------------------------------------------------------------------|'
'| Initializes all controls. CALL ONLY ONCE                                 |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

CreateForm 1, 100, 10, 405, 190, "Amethyst", "Striped", true, true
CreateLabel 1, 1, 4, 36, 310, 12, "Mouse X:", 0, true
CreateLabel 2, 1, 4, 54, 310, 70, "Mouse Y:", 0, true
CreateLabel 3, 2, 5, 9, 185, 12, "C:\>", 11, true
CreateProgress 1, 1, 70, 32, 290, 48, 639, true
CreateProgress 2, 1, 70, 50, 290, 66, 479, true
CreateLight 1, 1, 5, 5, 15, 15, true
CreateLight 2, 1, 20, 5, 30, 15, true
button(1).x = 50
button(1).y = 5
button(1).xx = 100
button(1).yy = 20
button(1).caption = "Text"
button(1).visible = 1
button(1).form = 3
END SUB

SUB getinfo

'|--------------------------------------------------------------------------|'
'| GetInfo                                                                  |'
'|--------------------------------------------------------------------------|'
'| Currently does nothing, but will eventually read the INI file            |'
'|                                                                          |'
'| Uses QuickReference (tm) technology                                      |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

END SUB

FUNCTION GetTBSize (num)
'GetTBSize = form(num).TByy - TBy
GetTBSize = 15
END FUNCTION

SUB initialize

'|--------------------------------------------------------------------------|'
'| Initialize                                                               |'
'|--------------------------------------------------------------------------|'
'| Initializes                                                              |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

SCREEN screenmode
FOR n = 1 TO 10
form(n).style = "_"
winorder(n) = n
NEXT
getinfo
forminfo
AMsystem.forcerefresh = 1
AMsystem.defaultcursor = "ARROW"
CLS
mouseinit
END SUB

SUB Main

'|--------------------------------------------------------------------------|'
'| Main                                                                     |'
'|--------------------------------------------------------------------------|'
'| Handles the Amethyst Interface                                           |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

refresh
APImousecursor AMsystem.defaultcursor
DO
a$ = INKEY$
SELECT CASE a$
CASE CHR$(27)
APIerror "User", 1, 0
CASE ">"
Last = winorder(0)
nextwin:
winorder(0) = winorder(0) + 1
IF winorder(0) > maxforms THEN winorder(0) = 1
IF form(winorder(0)).visible = 0 THEN GOTO nextwin:
IF winorder(0) <> Last THEN AMsystem.forcerefresh = 1: refresh
CASE "<"
Last = winorder(0)
prevwin:
winorder(0) = winorder(0) - 1
IF winorder(0) < 1 THEN winorder(0) = maxforms
IF form(winorder(0)).visible = 0 THEN GOTO prevwin:
IF winorder(0) <> Last THEN AMsystem.forcerefresh = 1: refresh
CASE "-"
IF form(winorder(0)).visible = 1 THEN
form(winorder(0)).visible = 0
FOR n = 1 TO maxforms
IF form(n).visible = 1 THEN
winorder(0) = n
EXIT FOR
END IF
NEXT
refresh
END IF
END SELECT
multitask
AMsystem.forcerefresh = 0
LOOP
END SUB

SUB MouseDriver (ax%, bx%, cx%, dx%)

'|--------------------------------------------------------------------------|'
'| Mousedriver (ax, bx, cx, dx)                                             |'
'|--------------------------------------------------------------------------|'
'| Sets the registers AX, BX, CX and DX, then calles the mouse interupt     |'
'| Extracted from QDesk                                                     |'
'|                                                                          |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

  DEF SEG = VARSEG(MOUSE$)
  MOUSE% = SADD(MOUSE$)
  CALL Absolute(ax%, bx%, cx%, dx%, MOUSE%)
END SUB

SUB mouseinit

'|--------------------------------------------------------------------------|'
'| Mouseinit                                                                |'
'|--------------------------------------------------------------------------|'
'| Initializes the mouse                                                    |'
'| Extracted from QDesk                                                     |'
'|                                                                          |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

  ax% = 0
  MouseDriver ax%, 0, 0, 0
IF NOT ax% THEN
  CLS
  PRINT "ERROR! - Mouse not found"
END IF
END SUB

SUB Mouseput (x%, y%)

'|--------------------------------------------------------------------------|'
'| Mouseput (x, y)                                                          |'
'|--------------------------------------------------------------------------|'
'| Sets the mouse co-ordinates                                              |'
'| Extracted from QDesk                                                     |'
'|                                                                          |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

ax% = 4
cx% = x%
dx% = y%
MouseDriver ax%, 0, cx%, dx%
END SUB

SUB mousestatus (lb%, rb%, Xmouse%, Ymouse%)

'|--------------------------------------------------------------------------|'
'| Mousestatus (lb, rb, x, y)                                               |'
'|--------------------------------------------------------------------------|'
'| Returns mouse status                                                     |'
'| Extracted from QDesk                                                     |'
'|                                                                          |'
'| Last Modified: 17/8/99                                                   |'
'|--------------------------------------------------------------------------|'

  ax% = 3
  MouseDriver ax%, bx%, cx%, dx%
  lb% = ((bx% AND 1) <> 0)
  rb% = ((bx% AND 2) <> 0)
  Xmouse% = cx%
  Ymouse% = dx%
END SUB

SUB multitask

'|--------------------------------------------------------------------------|'
'| multitask                                                                |'
'|--------------------------------------------------------------------------|'
'| The main Multitasking loop of Amethyst                                   |'
'| If you want anything to happen at run-time, put it here                  |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

AMsystem.internaltimer = AMsystem.internaltimer + 1
IF AMsystem.internaltimer = ScreenSaverDelay THEN APIscreensaver
IF trim$(AMsystem.cursormode) = "ANIMATED" THEN
DIM Regs AS RegType
Regs.ax = 9: Regs.bx = Hotx: Regs.cx = Hoty
Regs.dx = SADD(anmcur$(AMsystem.anmcurtimer))
CALL INTERRUPT(&H33, Regs, Regs)
AMsystem.anmcurtimer = 1
'amsystem(0).anmcurtimer = amsystem(0).anmcurtimer + 1
'IF amsystem(0).anmcurtimer = 9 THEN amsystem(0).anmcurtimer = 1
'AMmouseshow
'AMmousehide
END IF
Progress(1).cur = AMmousex
Progress(2).cur = AMmousey
Light(1).onoff = 0
IF AMmouselb = -1 THEN Light(1).onoff = 1
Light(2).onoff = 0
IF AMmouserb = -1 THEN Light(2).onoff = 1
DrawLight 1
DrawLight 2
DrawProgress 1
DrawProgress 2
END SUB

SUB refresh

'|--------------------------------------------------------------------------|'
'| refresh                                                                  |'
'|--------------------------------------------------------------------------|'
'| Refreshes the screen.                                                    |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'
APImousecursor "Timer.cur"
desktop
FOR n = 1 TO maxforms
IF form(n).visible = 1 THEN
DrawForm n
END IF
NEXT
APImousecursor AMsystem.defaultcursor
END SUB

SUB reorder (n)
winorder(0) = n
END SUB

SUB STICKS (Joyx%, JOYY%, BUT1%, BUt2%, BUT3%)

'|--------------------------------------------------------------------------|'
'| Sticks                                                                   |'
'|--------------------------------------------------------------------------|'
'| Returns Joystick Status                                                  |'
'|                                                                          |'
'| Extracted for Microsoft QuickBASIC Help                                  |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'


Joyx% = STICK(0)
JOYY% = STICK(1)

BUT1% = STRIG(1)
BUt2% = STRIG(5)
BUT3% = STRIG(7)
END SUB

SUB text (t$, x, y, c)

'|--------------------------------------------------------------------------|'
'| Text (Text$, x, y, color)                                                |'
'|--------------------------------------------------------------------------|'
'| Writes string in Text$ to position x, y using the default screen 12 font |'
'|                                                                          |'
'| Written by Joe (QBFiles)                                                 |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

x% = x
y% = y
a$ = t$
co% = c
Bkgd% = 256
SHADOW% = 0
IF systemfontengrave = 1 THEN SHADOW% = 15: co% = 0
DEFINT A-Z
extX% = 8: extY% = 0
DEF SEG = &HFFA6
 FOR I% = 1 TO LEN(a$)
   ADDR% = 8 * ASC(MID$(a$, I%)) + 14
IF Background% THEN
IF Background% = 256 THEN BG% = false ELSE BG% = Bkgd%
IF I% = LEN(a$) THEN extX% = false: extY% = false
LINE (x%, y%)-(x% + 8 + extX%, y% + 8 + extY%), BG%, BF
END IF
FOR j% = 0 TO 7: mask% = PEEK(ADDR% + j%) * 128
IF SHADOW% THEN
IF SHADOW% > 1 THEN
LINE (x% + 9, y% + j% + 2)-(x% + 1, y% + j% + 1), SHADOW%, , mask%
ELSE
LINE (x% + 9, y% + j% + 2)-(x% + 2, y% + j% + 2), 0, , mask%
END IF
END IF
LINE (x% + 8, y% + j%)-(x%, y% + j%), co%, , mask%
NEXT: x% = x% + extX%: y% = y% + extY%:  NEXT: DEF SEG
END SUB

DEFSNG A-Z
FUNCTION trim$ (a$)

'|--------------------------------------------------------------------------|'
'| Trim$ (Text$)                                                            |'
'|--------------------------------------------------------------------------|'
'| Returns a trimed version of the text in a$                               |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

trim$ = LTRIM$(RTRIM$(a$))
END FUNCTION

SUB xyform (x, y, xx, yy, title$, active)

'|--------------------------------------------------------------------------|'
'| XYform (x, y, xx, yy, title$, active)                                    |'
'|--------------------------------------------------------------------------|'
'| Draws a deafault Amethyst style form                                     |'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'

tbcol = coltbinactive
tbcol = coltbinactive
IF active = 1 THEN tbcol = coltbactive
IF formfile$ = "Default" THEN
LINE (x, y)-(xx, yy), col3d, BF
LINE (x, y)-(xx, y + tbheight), tbcol, BF
bevel x, y, xx, yy, 2
SELECT CASE systemtbtextalign
CASE 1
text trim$(title$), x + 5, y + 5, coltbtext
CASE 3
text trim$(title$), xx - 5 - APItextwidth(title$), y + 5, coltbtext
CASE 2
APItextarea trim(title$), x, y + 3, xx, y + 15
END SELECT
END IF
END SUB

SUB xyformcustom (style$)

'|--------------------------------------------------------------------------|'
'| XYformCustom                                                             |'
'|--------------------------------------------------------------------------|'
'| Draws a custom form. Style$ is the filename of the *.GUI file to load    |'
'|==========================================================================|'
'| UNDER CONSTRUCTION  UNDER CONSTRUCTION  UNDER CONSTRUCTION  UNDER CONSTR |
'|==========================================================================|'
'|                                                                          |'
'| Written by Ashley Oliver of Interplanitary Productions                   |'
'| Last Modified: 8/8/99                                                    |'
'|--------------------------------------------------------------------------|'


END SUB

