'$DYNAMIC
DEFINT A-Z
DECLARE SUB MakeBMP (filename$, sx, sy, ex, ey, nbits, imgnum, dosx)
DECLARE SUB Capture (Prefix$)
DECLARE SUB Display (Prefix$)

SCREEN 12
Display "MATRIX"
SLEEP
SLEEP
SLEEP
SLEEP

REM $STATIC
SUB Capture (Prefix$)
DEF SEG = &HA000
OUT &H3CE, 4 'tells the vga control what function we are going
'to use (in this case 4, change plane to read from)
FOR Plane = 0 TO 3
OUT &H3CF, Plane 'switches planes
BSAVE Prefix$ + LTRIM$(STR$(Plane)) + ".BSV", 0, 38400
NEXT Plane

END SUB

SUB Display (Prefix$)
DEF SEG = &HA000

OUT &H3C4, 2 'tells the vga control what function we are going
'to use (in this case 2, select what plane(s) to write to)
FOR Plane = 0 TO 3
OUT &H3C5, 2 ^ Plane 'switches planes
BLOAD Prefix$ + LTRIM$(STR$(Plane)) + ".BSV", 0
NEXT Plane
END SUB

SUB MakeBMP (filename$, sx, sy, ex, ey, nbits, imgnum, dosx)
IF filename$ = "" THEN
  filename$ = "CAP" + LTRIM$(RTRIM$(STR$(imgnum))) + ".BMP"
    imgnum = imgnum + 1
    END IF
   
    CLOSE #1
    OPEN filename$ FOR BINARY AS #1
    IF LOF(1) <> 0 THEN
      CLOSE #1
        KILL filename$
          OPEN filename$ FOR BINARY AS #1
          END IF
         
          va = &H3C7 'VGA Palette Read Address Register
          vd = &H3C9 'VGA Palette Data Register
         
          zero$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)
         
          'Check extents to order points.
          IF sx > ex THEN SWAP sx, ex
          IF sy > ey THEN SWAP sy, ey
         
          'Use Windows BMP Header. Size=40
          headersize = 40
         
          'Calculate Picture width,height
          picwidth = ex - sx + 1
          picheight = ey - sy + 1
         
          'Set Colour Information
          'Planes [W] - Must be 1
          nplanes = 1
         
          'Calculate offset [LW] to start of data
          IF nbits = 1 OR nbits = 4 OR nbits = 8 THEN
            offset = 14 + headersize + 4 * (2 ^ nbits)
            ELSE
              offset = 14 + headersize
              END IF
             
              'Type of file [W] (Should be BM)
              ft$ = "BM"
             
              'File Size [LW] (excluding header)
              IF nbits = 1 THEN
                IF (picwidth MOD 32) <> 0 THEN
                    filesize = 4 * (INT(picwidth / 32) + 1) * picheight
                      ELSE
 filesize = (picwidth / 8) * picheight
   END IF
   ELSEIF nbits = 4 THEN
     IF (picwidth MOD 8) <> 0 THEN
     filesize = 4 * (INT(picwidth / 8) + 1) * picheight
      ELSE
         filesize = (picwidth / 2) * picheight
           END IF
             ELSEIF nbits = 8 THEN
                   IF (picwidth MOD 4) <> 0 THEN
                       filesize = 4 * (INT(picwidth / 4) + 1) * picheight
                ELSE
                    filesize = picwidth * picheight
                    END IF
           ELSEIF nbits = 24 THEN
             IF (3 * picwidth MOD 4) <> 0 THEN
                 filesize = 4 * (INT(3 * picwidth / 4) + 1) * picheight
                   ELSE
                       filesize = 3 * picwidth * picheight
END IF
END IF
                        
'Set reserved values [W] (both must be zero)
r1 = 0
r2 = 0
                        
'Compression type [LW] - None
comptype = 0
                        
'Image Size [LW]; Scaling Factors xsize, ysize unused.
imagesize = offset + filesize
xsize = 0
ysize = 0
                        
'Assume all colours used [LW] - 0 means all colours.
coloursused = 0
neededcolours = 0
                        
header$ = ft$ + MKL$(filesize) + MKI$(r1) + MKI$(r2) + MKL$(offset)
infoheader$ = MKL$(headersize) + MKL$(picwidth) + MKL$(picheight) + MKI$(nplanes)
infoheader$ = infoheader$ + MKI$(nbits) + MKL$(comptype) + MKL$(imagesize)
infoheader$ = infoheader$ + MKL$(xsize) + MKL$(ysize) + MKL$(coloursused)
infoheader$ = infoheader$ + MKL$(neededcolours)
                        
'Write headers to BMP File.
PUT #1, 1, header$
PUT #1, , infoheader$
                        
'Add palette - Get colours (Write as B0G0R0(0),B1G1R1(0),...)
IF nbits = 1 OR nbits = 4 OR nbits = 8 THEN
  palet$ = ""
    OUT va, 0
      FOR count = 1 TO 2 ^ nbits
          zr = INP(vd) * 4
              zg = INP(vd) * 4
                  zb = INP(vd) * 4
  palet$ = palet$ + CHR$(zb) + CHR$(zg) + CHR$(zr) + CHR$(0)
    NEXT count
      PUT #1, , palet$
        palet$ = "" 'Save some memory
        END IF
       
       
        stpoint = POINT(sx, ey + 1)
       
        'BMPs are arranged with the top of the image at the bottom of the file.
        'Get points off the screen and pack into bytes depending on the number of
        'bits used. Deal with unused bits at the end of the line.
        'Check for invalid range.
        FOR count2 = ey TO sy STEP -1
          
            'LOCATE 1, 1: PRINT count2, ey, sy
              IF count2 < 198 THEN
                  IF dosx = 1 THEN
                      dosx = 0
             END IF
               END IF
                   
 lin$ = ""
   IF nbits = 1 THEN
       count1 = sx
           WHILE count1 <= ex
                IF count1 + 7 > ex THEN
                     t = 0
  FOR count0 = 0 TO 7
          p = POINT(count1 + count0, count2)
                  IF p < 0 THEN p = 0
      t = t + (2 ^ (7 - count0)) * (p MOD 2)
            NEXT count0
                  t2 = ex - count1 + 1
                        t = t AND ((2 ^ t2) - 1) * (2 ^ (8 - t2))
     lin$ = lin$ + CHR$(t)
          ELSE
               t = 0
 FOR count0 = 0 TO 7
         p = POINT(count1 + count0, count2)
                 IF p < 0 THEN p = 0
 t = t + (2 ^ (7 - count0)) * (p MOD 2)
       NEXT count0
       lin$ = lin$ + CHR$(t)
                  END IF
  count1 = count1 + 8
     WEND
       ELSEIF nbits = 4 THEN
           count1 = sx
               WHILE count1 <= ex
                    IF count1 = ex THEN
p = POINT(count1, count2)
      IF p < 0 THEN p = 0
      lin$ = lin$ + CHR$((p MOD 16) * 16)
            lin$ = lin$ + CHR$((p MOD 16) * 16)
                 ELSE
  p = POINT(count1, count2)
        p2 = POINT(count1 + 1, count2)
              IF p < 0 THEN p = 0
                    IF p2 < 0 THEN p2 = 0
 lin$ = lin$ + CHR$((p MOD 16) * 16 + p2)
      END IF
      count1 = count1 + 2
          count1 = count1 + 2
             WEND
               ELSEIF nbits = 8 THEN
                   FOR count1 = sx TO ex
    p = POINT(count1, count2)
        IF p < 0 THEN p = 0
            lin$ = lin$ + CHR$(p)
               NEXT count1
                 ELSEIF nbits = 24 THEN
                     'I'm not sure what to put here. QBasic doesn't support truecolour
'Unused for now.
  END IF
                     
    'Pad line to LongWord boundary
      IF (LEN(lin$) MOD 4) <> 0 THEN
      lin$ = lin$ + MID$(zero$, 1, 4 - (LEN(lin$) MOD 4))
          lin$ = lin$ + MID$(zero$, 1, 4 - (LEN(lin$) MOD 4))
      END IF
    'Write the current line to the BMP file'Write the current line to the BMP file
'Write the current line to the BMP file
  PUT #1, , lin$
                
  NEXT count2
                
  'Save some memory
  lin$ = ""
                
  PSET (sx, count2 + 1), stpoint
                
  'Close the file
  CLOSE
  'END SUB
  'MakeBMP (filename$, sx, sy, ex, ey, nbits, imgnum, dosx)

END SUB

