DECLARE SUB mousedriver (ax%, bx%, cx%, dx%)
DECLARE SUB MouseHide ()
DECLARE SUB MouseShow ()
DECLARE SUB MouseStatus (lb%, rb%, xMouse%, yMouse%)
DECLARE FUNCTION MouseLimit% (MiniX%, MiniY%, MaxiX%, MaxiY%)
DECLARE FUNCTION MouseInOut% (Left%, Up%, text1$, InOut%)
DECLARE FUNCTION mouseinit% ()
DIM SHARED MOUSE$
MOUSE$ = SPACE$(57)
FOR I% = 1 TO 57
    READ a$
    H$ = CHR$(VAL("&H" + a$))
    MID$(MOUSE$, I%, 1) = H$
NEXT I%
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

SCREEN 12                                 ' High Resolution.
LOCATE 14, 29                             ' Where the words go.
FOR i% = 1 TO 700                         ' How many pixels
 PSET (i%, 220), 7                        '  to move across the screen.
 PSET (i%, 210), 8
FOR delay% = 1 TO 500                     ' How fast it goes.
NEXT delay%
NEXT i%
'SLEEP 1
DO                                        ' Do the do....for your loop.
FOR j% = 100 TO 300
RANDOMIZE TIMER                           ' Makes Random Numbers.
 x% = INT(RND * 600) + 1
 y% = INT(RND * 600) + 1
 c% = INT(RND * 15) + 1
CIRCLE (j%, x%), y%, c%                   ' Random Circle Sizes.
LINE (y%, x%)-(x%, y%), c%, BF     
MouseStatus lbutton%, rbutton%, x%, y%
IF lbutton% = -1 THEN END        ' Random Sized/Filled Circles.
IF rbutton% = -1 THEN END
IF NOT x% = x% THEN END
IF NOT y% = y% THEN END
FOR delay% = 1 TO 200: NEXT delay%
NEXT j%

LOOP                ' Keeps going until ESCAPE is pressed.
                         ' Goes to my subroutine PasswordSub.
END

SUB mousedriver (ax%, bx%, cx%, dx%)

  DEF SEG = VARSEG(MOUSE$)
  MOUSE% = SADD(MOUSE$)
  CALL ABSOLUTE(ax%, bx%, cx%, dx%, MOUSE%)

END SUB

SUB MouseHide
 ax% = 2
 mousedriver ax%, 0, 0, 0
END SUB

FUNCTION mouseinit%
  ax% = 0
  mousedriver ax%, 0, 0, 0
  mouseinit% = ax%
END FUNCTION

'/* This function handles the mouse when it is clicking a button           */'
FUNCTION MouseInOut (Left, Up, text1$, InOut)

MouseInOutx = 0
Right = LEN(text1$) * 8 + 52: Down = 23

CALL BUTTON2(Left, Up, 1, text1$, 0)
DO
    CALL MouseStatus(LeftButton, RightButton, xMouse, yMouse)
    IF InOut = 1 THEN
        IF MouseLimit(Left, Up, Right, Down) = 0 THEN
            CALL MouseHide
            CALL BUTTON2(Left, Up, 0, text1$, 0)
            CALL MouseShow
            MouseInOutx = 2: EXIT FUNCTION
        END IF
    END IF
LOOP UNTIL LeftButton = 0
CALL BUTTON2(Left, Up, 0, text1$, 0)

END FUNCTION

'/* This function checks if the mouse is located in a given area           */'
FUNCTION MouseLimit (MiniX, MiniY, MaxiX, MaxiY)

MouseLimit = 0
CALL MouseStatus(LeftButton, RightButton, xMouse, yMouse)

IF xMouse >= MiniX AND xMouse <= MiniX + MaxiX THEN
    IF yMouse >= MiniY AND yMouse <= MiniY + MaxiY THEN
        MouseLimit = -1
    END IF
END IF

END FUNCTION

'DEFLNG A-Z
SUB MousePut (x%, y%)
  ax% = 4
  cx% = x%
  dx% = y%
  mousedriver ax%, 0, cx%, dx%
END SUB

'DEFLNG A-Z
SUB MouseRange (x1%, y1%, x2%, y2%)
  ax% = 7
  cx% = x1%
  dx% = x2%
mousedriver ax%, 0, cx%, dx%
  ax% = 8
  cx% = y1%
  dx% = y2%
  mousedriver ax%, 0, cx%, dx%
END SUB

'DEFLNG A-Z
SUB MouseShow
  ax% = 1
  mousedriver ax%, 0, 0, 0
END SUB

'DEFLNG A-Z
SUB MouseStatus (lb%, rb%, xMouse%, yMouse%)
  ax% = 3
  mousedriver ax%, bx%, cx%, dx%
  lb% = ((bx% AND 1) <> 0)
  rb% = ((bx% AND 2) <> 0)
  xMouse% = cx%
  yMouse% = dx%
END SUB
