DECLARE FUNCTION StartSoundBlaster! ()
DECLARE FUNCTION Ulong2int% (Ulong&)
DECLARE SUB Convert2 (Bseg&, Boff&, L&)
DECLARE SUB Convert4 (Bseg&, Boff&, L&)
DECLARE FUNCTION int2ULong& (signedint%)
DECLARE FUNCTION DMADone% (DMA17%, L1&)
DECLARE FUNCTION ResetDSP% ()
DECLARE SUB MasterVolume (Right%, Left%, Getvol%)
DECLARE SUB WriteDSP (byte%)
DECLARE SUB SetStereo (OnOff%)
DECLARE FUNCTION ReadDSP% ()
DECLARE SUB SpeakerState (OnOff%)
DECLARE SUB DMAPlay (Segment&, Offset&, Length&, Freq&, StereoWav%)
DECLARE SUB DMAPlay16 (Segment&, Offset&, L&, Freq&, StereoWav%)
DECLARE FUNCTION GetBLASTER! ()
DECLARE FUNCTION DSPVersion! ()
COMMON SHARED Baseport%, LenPort%, DMA%, DMA16%, cardversion%, LMBCN&
'$DYNAMIC

REM $STATIC
SUB Convert2 (Bseg&, Boff&, L&)
DEF SEG = Ulong2int(Bseg&)
FOR I = 0 TO L& - 1 STEP 8
    addr = I + Boff&
    hibyte% = PEEK(addr + 1)    'i+1
    POKE Boff& + I \ 4, hibyte% + &H80
    hibyte% = PEEK(addr + 3)    'i+4
    POKE Boff& + I \ 4 + 1, hibyte% + &H80
NEXT

END SUB

SUB Convert4 (Bseg&, Boff&, L&)
DEF SEG = Ulong2int(Bseg&)
FOR I = 0 TO L& - 1 STEP 2
    addr = I + Boff&
    hibyte% = PEEK(addr + 1)    'i+1
    POKE Boff& + I \ 2, hibyte% + &H80
NEXT

END SUB

FUNCTION DMADone% (DMA17%, L1&)
countlo% = INP(LenPort%)
counthi% = INP(LenPort%)
count& = CLNG(counthi% * 256&) + CLNG(countlo%)
IF count& >= L1& - 1 THEN
   IF DMA17% THEN
      ack16% = INP(Baseport% + &HF)
   ELSE
      ack% = INP(Baseport% + &HE)
   END IF
   DMADone% = -1
END IF
END FUNCTION

SUB DMAPlay (Segment&, Offset&, Length&, Freq&, StereoWav%)
Length& = Length& - 1
page% = 0
addr& = Segment& * 16 + Offset&
SELECT CASE DMA%
    CASE 0
       PgPort% = &H87
       AddPort% = &H0
       LenPort% = &H1
       ModeReg% = &H48
    CASE 1
       PgPort% = &H83
       AddPort% = &H2
       LenPort% = &H3
       ModeReg% = &H49
    CASE 2
       PgPort% = &H81
       AddPort% = &H4
       LenPort% = &H5
       ModeReg% = &H4A
    CASE 3
       PgPort% = &H82
       AddPort% = &H6
       LenPort% = &H7
       ModeReg% = &H4B
    CASE ELSE
       PRINT "Error": END
       EXIT SUB
END SELECT
Lengthlo% = Length& AND &HFF
Lengthhi% = (Length& AND &HFF00&) \ &H100
IF StereoWav% THEN SetStereo 1
OUT &HA, &H4 + DMA%
OUT &HC, &H0
OUT &HB, ModeReg%
OUT AddPort%, addr& AND &HFF
OUT AddPort%, (addr& AND &HFF00&) \ &H100
IF (addr& AND 65536) THEN page% = page% + 1
IF (addr& AND 131072) THEN page% = page% + 2
IF (addr& AND 262144) THEN page% = page% + 4
IF (addr& AND 524288) THEN page% = page% + 8
OUT PgPort%, page%
OUT LenPort%, Lengthlo%
OUT LenPort%, Lengthhi%
OUT &HA, DMA%

TimeConst% = 256 - 1000000 \ Freq&

IF Freq& < 22728 THEN
   WriteDSP &H40
   WriteDSP TimeConst%
   WriteDSP &H14
   WriteDSP (Length& AND &HFF)
   WriteDSP ((Length& AND &HFFFF&) \ &H100)
ELSE
   IF cardversion% = 3 THEN
      WriteDSP &H40
      WriteDSP TimeConst%
      WriteDSP &H48
      WriteDSP Lengthlo%
      WriteDSP Lengthhi%
      WriteDSP &H91
   ELSE
      EXIT SUB
   END IF
END IF
END SUB

SUB DMAPlay16 (Segment&, Offset&, L&, Freq&, StereoWav%)

IF cardversion% < 4 THEN PRINT "Error": END
L& = L& - 1: page% = 0
addr& = Segment& * 16 + Offset&

SELECT CASE DMA16%
    CASE 4
       PgPort% = &H0
       AddPort% = &HC0
       LenPort% = &HC2
       ModeReg% = &H48
    CASE 5
       PgPort% = &H8B
       AddPort% = &HC4
       LenPort% = &HC6
       ModeReg% = &H49
    CASE 6
       PgPort% = &H89
       AddPort% = &HC8
       LenPort% = &HCA
       ModeReg% = &H4A
    CASE 7
       PgPort% = &H8A
       AddPort% = &HCC
       LenPort% = &HCE
       ModeReg% = &H4B
    CASE ELSE
       EXIT SUB
END SELECT

page% = (addr& \ 131072) * 2
Offset2& = (addr& - (page% * 65536)) \ 2
Lengthlo% = ((L& \ 2) AND &HFF)
Lengthhi% = (((L& \ 2) AND &HFF00&) \ &H100)

OUT &HD8, 0
OUT &HD6, ModeReg%
OUT AddPort%, (Offset2& AND &HFF)
OUT AddPort%, (Offset2& AND &HFF00&) \ &H100
OUT PgPort%, page%
OUT LenPort%, Lengthlo%
OUT LenPort%, Lengthhi%
OUT &HD4, DMA16% - 4

FreqHi% = (Freq& AND &HFF00&) \ &H100
FreqLo% = Freq& AND &HFF
WriteDSP &H41
WriteDSP FreqHi%
WriteDSP FreqLo%
WriteDSP &HB0
IF StereoWav% THEN
   WriteDSP &H30
ELSE
   WriteDSP &H10
END IF
WriteDSP Lengthlo%
WriteDSP Lengthhi%

END SUB

SUB DMAState (StopGo%)
IF StopGo% THEN WriteDSP &HD4 ELSE WriteDSP &HD0
END SUB

FUNCTION DSPVersion!
WriteDSP &HE1
Temp% = ReadDSP%
Temp2% = ReadDSP%
DSPVersion! = VAL(STR$(Temp%) + "." + STR$(Temp2%))
END FUNCTION

FUNCTION GetBLASTER

IF LEN(ENVIRON$("BLASTER")) = 0 THEN GetBLASTER = 1: EXIT FUNCTION
FOR index% = 1 TO LEN(ENVIRON$("BLASTER"))
   SELECT CASE MID$(ENVIRON$("BLASTER"), index%, 1)
      CASE "A"
        Baseport% = VAL("&H" + MID$(ENVIRON$("BLASTER"), index% + 1, 3))
      CASE "I"
        IRQ% = VAL(MID$(ENVIRON$("BLASTER"), index% + 1, 1))
      CASE "D"
        DMA% = VAL(MID$(ENVIRON$("BLASTER"), index% + 1, 1))
      CASE "H"
        DMA16% = VAL(MID$(ENVIRON$("BLASTER"), index% + 1, 1))
   END SELECT
NEXT

END FUNCTION

FUNCTION int2ULong& (signedint%)
IF signedint% < 0 THEN
        int2ULong& = CLNG(signedint% + 65536)
ELSE
        int2ULong& = CLNG(signedint%)
END IF
END FUNCTION

SUB MasterVolume (Right%, Left%, Getvol%)
OUT Baseport% + 4, &H22
IF Getvol% THEN
   Left% = INP(Baseport% + 5) \ 16
   Right% = INP(Baseport% + 5) AND &HF
   EXIT SUB
ELSE
   OUT Baseport% + 5, (Right% + Left% * 16) AND &HFF
END IF
END SUB

SUB PlayWaveAudio (varseg1%, varptr1%, Channels%, Freq&, Bits%, Length&)

DO UNTIL DMADone%(DMA16%, LMBCN&)
LOOP

Bseg& = int2ULong&(varseg1%)
Boff& = int2ULong&(varptr1%)

IF BitPerSample = 16 THEN SixteenBit% = 1
IF Channels = 2 THEN
   StereoWav% = 1
ELSE
   StereoWav% = 0
END IF

css = cardversion% = 3 AND SixteenBit% AND StereoWav%
cmm = cardversion% = 3 AND SixteenBit% AND NOT StereoWav%

L& = Length&
IF css THEN Convert2 Bseg&, Boff&, L&
IF cmm THEN Convert4 Bseg&, Boff&, L&

IF SixteenBit% THEN
    SELECT CASE cardversion%
    CASE 4
        DMAPlay16 Bseg&, Boff&, L&, Freq&, StereoWav%
    CASE 3
        IF StereoWav% THEN
            NL& = L& \ 4: L& = NL&
            DMAPlay Bseg&, Boff&, NL&, Freq&, StereoWav%
        ELSE
            NL& = L& \ 2: L& = NL&
            DMAPlay Bseg&, Boff&, NL&, Freq&, StereoWav%
        END IF
    CASE ELSE
        PRINT "Error": END
    END SELECT
ELSE
   IF StereoWav% THEN
       SELECT CASE cardversion%
           CASE 3
               DMAPlay Bseg&, Boff&, L&, Freq& * 2, StereoWav%
           CASE 4
               DMAPlay Bseg&, Boff&, L&, Freq& * 2, StereoWav%
           CASE ELSE
               PRINT "Error": END
       END SELECT
   ELSE
       DMAPlay Bseg&, Boff&, L&, Freq&, StereoWav%
   END IF
END IF
LMBCN& = L&

END SUB

FUNCTION ReadDSP%
WAIT (Baseport% + &HE), &H80
DO: DSPIn% = INP(Baseport% + 10): LOOP UNTIL DSPIn% <> &HAA
ReadDSP% = DSPIn%
END FUNCTION

FUNCTION ResetDSP%
ct = 0: stat = 0: ready = &HAA
OUT Baseport% + &H6, 1
DO
        OUT Baseport% + &H6, 0
        stat = INP(Baseport% + &HE)
        stat = INP(Baseport% + &HA)
        IF stat = ready THEN EXIT DO
        ct = ct + 1
LOOP WHILE ct < 100
IF stat = ready THEN ResetDSP% = 1 ELSE ResetDSP% = 0
END FUNCTION

SUB SetStereo (OnOff%)
MixerReg% = Baseport% + 4
MixerData% = Baseport% + 5
        OUT MixerReg%, &HE
        IF OnOff% THEN
                OUT MixerData%, 2
        ELSE
                OUT MixerData%, 0
        END IF
END SUB

SUB SpeakerState (OnOff%)
IF OnOff% THEN WriteDSP &HD1 ELSE WriteDSP &HD3
END SUB

FUNCTION StartSoundBlaster

IF GetBLASTER = 1 THEN StartSoundBlaster = 1: EXIT FUNCTION
IF ResetDSP% = 0 THEN StartSoundBlaster = 1: EXIT FUNCTION
cardversion% = FIX(DSPVersion!)
IF DMA16% = 0 AND cardversion% >= 4 THEN StartSoundBlaster = 1: EXIT FUNCTION
IF DMA% = 0 THEN StartSoundBlaster = 1: EXIT FUNCTION

SpeakerState 1
MasterVolume 10, 10, 0
MasterVolume Right%, Left%, -1

END FUNCTION

FUNCTION Ulong2int% (Ulong&)
IF Ulong& > 32767 THEN
        Sint% = CINT(Ulong& - 65536)
ELSE
        Sint% = CINT(Ulong&)
END IF
Ulong2int% = Sint%

END FUNCTION

SUB WriteDAC (byte%)
WriteDSP &H10
WriteDSP byte%
END SUB

SUB WriteDSP (byte%)
DO: LOOP WHILE INP(Baseport% + 12) AND &H80
OUT Baseport% + 12, byte%
END SUB

