DECLARE SUB NewWord (W$)
'       The one and only
'BASIC speech engine 2.0 by Steven M
'StevenM86aol.com
'http://members.aol.com/StevenM86/
'                                    
'-----------------------------------------------------
'Credits:
'
'Wave Player taken from The Qbasic Page.
'http://www.wp.com/80948/qb/
'mallard@gcomm.com
'
'If this program does any damage to the computer you are using,
'I am not responsible for it. (Just in case).
'
'Please read the comments before trying to add speech to your own programs.
'It's a lot easier to so so if you read this first.
'
'This program takes whatever you type in, and converts it into speech.
'The program refers to a data file on how to say the words. If the
'word is not found there, then the program will prompt you for a way
'to pronounce it. Type in the string of sound codes, when prompted, and
'listen. If the program says the word correctly, choose "Y" and the word
'will be added to the database. If the program doesn't say the word right,
'choose "N" and try again.
'
'To get the program to say things, use the sub Say (Phrase$), or
'SayWord (Word$). Say (Phrase$) just processes every word in the
'phrase and passes it to SayWord.
'
'NOTE: If you want the program to say something, like, "Hello, world!",
'then you have to call the sub Say like this:
'Say "HELLO WORLD"
'No punctuation, nothing like that. Just words. For a pause, type [LONGPAUSE].
'For example:
'SAY "HELLO [LONGPAUSE] BYE"
'
'----------------SAYING NUMBERS-----------------------------
'The program has a built-in Value-to-text converter. The function NumWord$
'takes numbers or variables and returns the text form. Example:
'PRINT NumWord$(290) 'Output: TWO HUNDRED NINETY
'Example 2:
'
'A = 541
'Say NumWord$(A) 'Sound output: Five hundred fourty one.
'
'That's how I got it to say the base port adress and the random
'number in the demo.
'
'-----------------SOUND REFFERENCE GUIDE--------------------
'
'------------------WARNING!!!
'SOUNDS ARE CASE SENSITIVE!!! MAKE SURE YOU TYPE THE LETTER
'OF THE SOUND IN THE RIGHT CASE!!!
'
'In the oly version, if a word is said incorrectly, you had to stop the
'program, go to DATA, type something in, and retry. Not anymore!
'Now, if a word is not in the database, a screen comes up, prompting you
'to enter the the sound codes. A list of sound codes is in the comments
'below. It's also printed on the screen, so you don't have to look anything
'up. Once the word has beel learned, the program resumes.
'
'---- HOW SOUND CODES WORK:
'If you don't understand it, then here's an example:
'A as in bAnanA: a
'This means that the sound "A", like in the word Banana, has the
'symbol f. insert the letter "a" into the DATA statements to get
'this sound. If you don't understand, please email StevenM86@aol.com
'and I will be glad to help you. Well, here we go (It goes alphabetically):
'-------------------------------------------------------------------------
'A  as in bAnanA:    a
'A  as in mAp:       A
'A  as in bOther:    1
'Ay as in dAY:       2
'A  as in bAd:       3
'Aw as in nOW:       4
'Aw as in sAW:       5
'B  as in BaBy:      b
'Ch as in CHin:      c
'D  as in unDone:    d
'E  as in bEt:       e
'Ea as in bEAt:      E
'F  as in FiFty:     f
'G  as in Go:        g
'G  as in Gem:       G
'H  as in Hat:       h
'I  as in tIp:       i
'I  as in bUY:       I
'Ir as in bIRd:      j
'K  as in CooK:      k
'L  as in pooL:      l
'M  as in diM:       m
'N  as in No:        n
'Ng as in siNG:      N
'O  as in bOne:      o
'Oi as in cOIn:      O
'O  as in jOb:       6
'Oo as in wOOd:      7
'P  as in PePPer:    p
'R  as in RaRe:      r
'S  as in leSS:      s
'Sh as in SHy:       S
'T  as in aTTack:    t
'Th as in THen:      T
'Th as in THirteen:  H
'U  as in rUle:      u
'U  as in hUmdrUm:   U
'U  as in Union:     8
'U  as in cUrable:   9
'V  as in giVe:      v
'W  as in We:        w
'W  as in ONe:       W
'Z  as in raISE:     z
'Pause (about 25ms): 0
'------------------------------------------------------------------------
'That's it. (That was long!) I hope you like this program.
'       Written by Steven M.
'
DECLARE SUB PlayWav (WaveFile$)
DECLARE SUB ValidWavHeader (file$, LenHeader%, dataLen&, nChannels%, nSamplesPerSec&, nAvgBytesPerSec&, ok%)
DECLARE FUNCTION Replace$ (text$, LookFor$, ReplaceWith$)
DECLARE SUB GuessWord (WS$)
DECLARE FUNCTION ReplaceTXT$ (or$, RW$, WW$)
DECLARE FUNCTION NUMWORD$ (N%)
DECLARE SUB SAY (e$)            'THE SUB YOU NEED TO USE.
DECLARE SUB sayword (W$)        'YOU CAN USE THIS SO SAY INDIVIDUAL WORDS.
DECLARE SUB Caption ()          'UPDATES THE CLOSED CAPTION TO THE VAR. CC$
DECLARE SUB INIT ()             'INITIALIZES THE TALKING GUY.
DECLARE SUB TALKHEAD ()             'UPDATED THE TALKING GUY
DECLARE FUNCTION Capital! (L$)      'RETURNS 1 IF L$ IS A CAPITAL LETTER
DECLARE FUNCTION WordArray! (WORD$) 'LOOKS UP A WORD IN THE ARRAY AND RETURNS THE VALUE
DECLARE SUB WriteToDSP (V%)
DECLARE SUB PlayBack (BUFFER$, size%, FREQ&, BytesPerSec&, chans%, num%)
DECLARE SUB delay (tdelay!)
DECLARE FUNCTION GetBlasterAddr% ()
DECLARE FUNCTION SBreset% ()
COMMON SHARED BlasterAddr%, dma%, repeats%, HTO, oksk
PRINT "If you are running this program directly from WinZip, you must extract all"
PRINT "the files to a directory first. (Duh!)"
SHELL "cd >load.tst"
CLOSE #1
OPEN "load.tst" FOR INPUT AS #1
  INPUT #1, WAVs$
CLOSE #1
KILL "load.tst"
CLS
CHDIR WAVs$

RANDOMIZE TIMER
SCREEN 13: CLS ': DEF SEG = &HA000
DIM SHARED M1%(300), M2%(300), M3%(300), M4%(300)
DIM SHARED E1%(300), E2%(300), E4%(300), CC$, A1$(19), A2$(9)
TYPE WORDTYPE
WORD AS STRING * 20
SND AS STRING * 20
END TYPE
DIM SHARED Words(1000) AS WORDTYPE  'Space for 1000 words.
'                 '| increase this if you want more word space.
CLS
CLS
OPEN "Words.dat" FOR INPUT AS #1
DO UNTIL EOF(1)
A% = A% + 1
INPUT #1, AA$
INPUT #1, BB$
Words(A%).WORD$ = LTRIM$(RTRIM$(UCASE$(AA$)))
BB$ = LTRIM$(RTRIM$(BB$))
sr$ = ""
S$ = ""
Words(A%).SND$ = BB$
LOOP
CLOSE #1
Words(A% + 1).SND$ = "END OF LIST"
Words(A% + 1).WORD$ = "END OF LIST"
CLS
SLEEP 1
COLOR 15
BlasterAddr% = GetBlasterAddr%
PRINT "***** Initializing *****"
RESTORE NUMDATA
'SAY "PLEASE WAIT"
FOR J% = 1 TO 19: READ A1$(J%): NEXT
FOR J% = 1 TO 9: READ A2$(J%): NEXT
SLEEP 1
PRINT "***** SOUND CARD PORT: "; HEX$(BlasterAddr%); "H *****"
'SAY NUMWORD$(VAL(HEX$(BlasterAddr%)))
PRINT "***** Reading word data *****"
SLEEP 1
PRINT "** READY **"
PRINT
PRINT
CLS
PRINT "Type '[end]' to stop the speech engine..."
DO
INPUT ">", sentence$
IF LCASE$(sentence$) = "[end]" THEN
   END
END IF

SAY sentence$
LOOP
'SAY "HELLO [LONGPAUSE] HERE'S A RANDOM NUMBER [LONGPAUSE] " + NUMWORD$(A%)

NUMDATA:
DATA "ONE","TWO","THREE","FOUR","FIVE","SIX","SEVEN","EIGHT","NINE","TEN","ELEVEN","TWELVE"
DATA "THIRTEEN","FOURTEEN","FIFTEEN","SIXTEEN","SEVENTEEN","EIGHTEEN","NINETEEN"
DATA "TEN","TWENTY","THIRTY","FORTY","FIFTY","SIXTY","SEVENTY","EIGHTY","NINETY"
DEFINT A-Z

DEFSNG A-Z
FUNCTION Capital (L$)

IF L$ = UCASE$(L$) THEN Capital = 1 ELSE Capital = 0
END FUNCTION

SUB delay (tdelay!)
'talkhead
END SUB

DEFINT A-Z
'------------------------------------------------------------------------------
FUNCTION GetBlasterAddr%
'Get Blaster Address and DMA channel from Environment Variable
tmp% = 0  'No Environment Variable Set...default
blast$ = UCASE$(ENVIRON$("BLASTER"))
IF LEN(blast$) THEN
   tmp% = INSTR(blast$, "A")
   tmp1$ = MID$(blast$, tmp% + 1, 3)
   tmp% = VAL("&H" + tmp1$)
   IF tmp% = 203 THEN tmp% = -1    'If there is no value assigned
   IF tmp% > 0 THEN
      tmp2% = INSTR(blast$, "D")
      dma% = VAL(MID$(blast$, tmp2% + 1))        'dma% is a global variable
      IF dma% < 0 OR dma% > 7 THEN tmp% = -2
   END IF
END IF
GetBlasterAddr% = tmp%
END FUNCTION

DEFSNG A-Z
SUB GuessWord (WS$)
'Guess word routines worked badly, so I added the New Word sub.
NewWord WS$
END SUB

DEFINT A-Z
SUB NewWord (W$)
SCREEN 12
REENTER:
CLS
PRINT "*** UNKNOWN WORD ***"
PRINT "Input a list of sound codes for the word ''"; UCASE$(W$); "''."
PRINT "The sound codes are:"
PRINT "A  as in bAnanA:    a", , "A  as in mAp:       A"
PRINT "A  as in bOther:    1", , "Ay as in dAY:       2"
PRINT "A  as in bAd:       3", , "Aw as in nOW:       4"
PRINT "Aw as in sAW:       5", , "B  as in BaBy:      b"
PRINT "Ch as in CHin:      c", , "D  as in unDone:    d"
PRINT "E  as in bEt:       e", , "Ea as in bEAt:      E"
PRINT "F  as in FiFty:     f", , "G  as in Go:        g"
PRINT "G  as in Gem:       G", , "H  as in Hat:       h"
PRINT "I  as in tIp:       i", , "I  as in bUY:       I"
PRINT "Ir as in bIRd:      j", , "K  as in CooK:      k"
PRINT "L  as in pooL:      l", , "M  as in diM:       m"
PRINT "N  as in No:        n", , "Ng as in siNG:      N"
PRINT "O  as in bOne:      o", , "Oi as in cOIn:      O"
PRINT "O  as in jOb:       6", , "Oo as in wOOd:      7"
PRINT "P  as in PePPer:    p", , "R  as in RaRe:      r"
PRINT "S  as in leSS:      s", , "Sh as in SHy:       S"
PRINT "T  as in aTTack:    t", , "Th as in THen:      T"
PRINT "Th as in THirteen:  H", , "U  as in rUle:      u"
PRINT "U  as in hUmdrUm:   U", , "U  as in Union:     8"
PRINT "U  as in cUrable:   9", , "V  as in giVe:      v"
PRINT "W  as in We:        w", , "W  as in ONe:       W"
PRINT "Z  as in raISE:     z", , "Pause (about 25ms): 0"
INPUT "Sound codes? ", SC$
FOR B = 1 TO LEN(SC$)
S$ = MID$(SC$, B, 1)
IF S$ = " " THEN EXIT SUB
IF Capital(S$) THEN PlayWav "c" + S$ + ".wav" ELSE PlayWav S$ + ".wav":
NEXT B
PRINT "Was that the way you say ''"; W$; "''?  (Y/N)";
INPUT YN$
IF UCASE$(YN$) = "N" THEN GOTO REENTER
IF UCASE$(YN$) = "Y" THEN
PRINT "Teaching the program a new word..."
FFF = FREEFILE
OPEN "Words.dat" FOR APPEND AS FFF
PRINT #FFF, W$
PRINT #FFF, SC$
CLOSE
SLEEP 1
PRINT "Re-loading word list..."
OPEN "Words.dat" FOR INPUT AS #1
DO UNTIL EOF(1)
A% = A% + 1
INPUT #1, AA$
INPUT #1, BB$
Words(A%).WORD$ = LTRIM$(RTRIM$(UCASE$(AA$)))
BB$ = LTRIM$(RTRIM$(BB$))
sr$ = ""
S$ = ""
Words(A%).SND$ = BB$
LOOP
CLOSE #1
Words(A% + 1).SND$ = "END OF LIST"
Words(A% + 1).WORD$ = "END OF LIST"
END IF
SLEEP 1
PRINT "DONE!"
END SUB

FUNCTION NUMWORD$ (N%)
REM -- Subroutine to convert amt to alpha
t3 = N%
REM UP TO $ 999,999.99
TH = 0: HU = 0: TE = 0: UN = 0: AMT$ = ""
IF t3 >= 1000! THEN TH = FIX(t3 / 1000)
IF t3 >= 100! THEN HU = FIX((t3 - (TH * 1000)) / 100)
IF t3 >= 10! THEN TE = FIX((t3 - ((TH * 1000) + (HU * 100))) / 10)
IF t3 >= 1! THEN UN = FIX(t3 - ((TH * 1000) + (HU * 100) + (TE * 10)))
IF TE = 1! THEN TE = UN + 10: UN = 0
TEST = t3 - FIX(t3)
test2 = CINT(TEST * 100)
CTS$ = STR$(test2)
CTS = VAL(RIGHT$("00" + LTRIM$(CTS$), 2))
REM -- Thousands
XCOUNT = 0: SAVE.TH = 0
IF TH = 0! THEN GOTO 2360
IF TH > 19! THEN
SAVE.TH = TH
IF TH < 30 AND TH > 20 THEN AMT$ = "Twenty " + A1$(TH - 20) + " THOUSAND": GOTO 2360
IF TH = 20 THEN AMT$ = "TWENTY THOUSAND": GOTO 2360
XCOUNT = 2: SAVE.TH = SAVE.TH - 20
WHILE SAVE.TH > 0
SAVE.TH = SAVE.TH - 10: XCOUNT = XCOUNT + 1
WEND
SAVE.TH = SAVE.TH + 10: XCOUNT = XCOUNT - 1
IF XCOUNT > 9 THEN
XCOUNT = XCOUNT - 9
IF TH > 100 THEN XCOUNT = FIX(TH / 100): SAVE.TH = TH - (100 * XCOUNT)
IF TH > 100 AND SAVE.TH > 19 THEN
AMT$ = A1$(XCOUNT) + " HUNDRED " + A2$(FIX(SAVE.TH / 10)) + " " + A1$(SAVE.TH - (FIX(SAVE.TH / 10) * 10)) + " THOUSAND": GOTO 2360
END IF
AMT$ = A1$(XCOUNT) + " HUNDRED " + A1$(SAVE.TH) + " THOUSAND": GOTO 2360
ELSE
AMT$ = A2$(XCOUNT)
IF SAVE.TH > 0 THEN AMT$ = AMT$ + " " + A1$(SAVE.TH)
AMT$ = AMT$ + " THOUSAND": GOTO 2360
END IF
END IF
IF TH <= 19 THEN AMT$ = A1$(TH) + " THOUSAND"
2360 REM -- Hundreds
IF HU = 0! THEN GOTO 2400
IF AMT$ <> "" THEN AMT$ = AMT$ + " "
AMT$ = AMT$ + A1$(HU) + " HUNDRED"
2400 REM -- Tens
IF TE = 0! THEN GOTO 2450
IF AMT$ <> "" THEN AMT$ = AMT$ + " "
IF TE > 9! THEN AMT$ = AMT$ + A1$(TE): GOTO 2450
AMT$ = AMT$ + A2$(TE)
2450 REM -- Units
IF UN = 0! THEN NUMWORD$ = AMT$: EXIT FUNCTION
IF AMT$ <> "" THEN AMT$ = AMT$ + " "
AMT$ = AMT$ + A1$(UN)
IF t3 > 0 AND t3 < 1 THEN AMT$ = "NONE"
NUMWORD$ = AMT$
END FUNCTION

'------------------------------------------------------------------------------
SUB PlayBack (BUFFER$, size%, FREQ&, BytesPerSec&, chans%, num%)
FREQ& = FREQ& + 1650
size% = size% - 1
segment& = VARSEG(BUFFER$)
offset& = SADD(BUFFER$)
IF segment& < 0 THEN segment& = segment& + 65536
IF offset& < 0 THEN offset& = offset& + 65536
baseaddr& = segment& * 16 + offset&
look1% = VARPTR(baseaddr&)
look2% = VARPTR(size%)
SELECT CASE dma%
   CASE 0
      dmapage% = &H87   '135 decimal
      dmaaddr% = 0
      dmalen% = 1
   CASE 1
      dmapage% = &H83   '131 decimal
      dmaaddr% = 2
      dmalen% = 3
   CASE 2
      dmapage% = &H81
      dmaaddr% = 4
      dmalen% = 5
   CASE 3
      dmapage% = &H82
      dmaaddr% = 6
      dmalen% = 7
   CASE 4
      dmapage% = &H8F
      dmaaddr% = &HC0
      dmalen% = &HC2
   CASE 5
      dmapage% = &H8B
      dmaaddr% = &HC4
      dmalen% = &HC6
   CASE 6
      dmapage% = &H89
      dmaaddr% = &HC8
      dmalen% = &HCA
   CASE 7
      dmapage% = &H8A
      dmaaddr% = &HCC
      dmalen% = &HCE
END SELECT
SELECT CASE dma%
   CASE 0 TO 3
      dmamask% = &HA
      dmamode% = &HB
      dmaclear% = &HC
      dmastatus% = &H8
   CASE 4 TO 7
      dmamask% = &HD4
      dmamode% = &HD6
      dmaclear% = &HD8
      dmastatus% = &HD0
END SELECT
SELECT CASE dma%
   CASE 0, 4
      dmaterminal% = 1   'bit 0 of status register (&H08 or &HD0)
   CASE 1, 5
      dmaterminal% = 2   'bit 1
   CASE 2, 6
      dmaterminal% = 4   'bit 2
   CASE 3, 7
      dmaterminal% = 8   'bit 3
END SELECT

OUT dmamask%, dma% + 4   'mask the dma channel
OUT dmaclear%, &H0       '(clear the internal DMA flip/flop)
OUT dmamode%, 72 + dma%  '  72=010010XX where XX=dmachannel%
OUT dmaaddr%, PEEK(look1%)      'bits 0-7 of  the 20bit address
OUT dmaaddr%, PEEK(look1% + 1)  'bits 8-15 of the 20bit address
OUT dmapage%, PEEK(look1% + 2)  'bits 16-19 of the 20 bit address
OUT dmalen%, PEEK(look2%)       'bits 0-7 of size%
OUT dmalen%, PEEK(look2% + 1)   'bits 8-15  of size%
OUT dmamask%, dma%              'enable channel

IF num% = 1 THEN  'only need to Write out time constant once
   timeconst% = 256 - 1000000 / (FREQ& * chans%)
   CALL WriteToDSP(&H40)
   CALL WriteToDSP(timeconst%)
   'Reset Mixer    DSPmixeraddress = Blasteraddr% + &H4
   OUT BlasterAddr% + &H4, &H0
   OUT BlasterAddr% + &H4 + 1, 0
   'Set Volume to Maximum...255
   OUT BlasterAddr% + &H4, &H22
   OUT BlasterAddr% + &H4 + 1, 25
5
   IF chans% = 2 THEN
      'Set mixer to Stereo Output
      OUT BlasterAddr% + &H4, &HE
      OUT BlasterAddr% + &H4 + 1, 34      '34=2^5+2^1
   END IF
END IF
IF BytesPerSec& > 22000 THEN
   CALL WriteToDSP(&H48)   'Set Block Size
ELSE
   CALL WriteToDSP(&H14)   'DMA Mode 8-bit DAC
END IF
CALL WriteToDSP(PEEK(look2%))      'Lo byte of address
CALL WriteToDSP(PEEK(look2% + 1))  'High byte of address
IF BytesPerSec& > 22000 THEN CALL WriteToDSP(&H91)  'High Speed DMA mode 8-bit
dummy% = INP(dmastatus%)    'Read status byte once to make sure DMA is going.
WAIT dmastatus%, dmaterminal%   'Loop until terminal count bit set in DMA status register
'DMA Transfer is Now Complete
'Acknowledge the DSP interrupt by reading the DATA AVAILABLE port once
dummy% = INP(BlasterAddr% + &HE)    'DSP Available address
END SUB

DEFSNG A-Z
SUB PlayWav (WaveFile$)
'IF wavefile$ = "c .wav" THEN EXIT SUB
'PRINT wavefile$
repeats% = 1
'BLASTERADDR% = GetBlasterAddr%
SELECT CASE BlasterAddr%
   CASE -2
      PRINT "Bad DMA Channel specified!"
      END
   CASE -1
      PRINT "No Port Base Address Given!"
      END
   CASE 0
      PRINT "No BLASTER Environment Variable Set!"
   CASE ELSE
      'Assume a valid Address Exists
'      PRINT "Blaster Address = "; HEX$(BlasterAddr%)
END SELECT
IF NOT SBreset% THEN
   PRINT "SoundBlaster Card Would Not Reset!"
END IF
sp% = INSTR(Spec$, " ")
IF sp% THEN
   WaveFile$ = LEFT$(Spec$, sp% - 1)
   repeats% = VAL(RIGHT$(Spec$, LEN(Spec$) - sp%))
   IF repeats% = 0 THEN repeats% = 1
ELSE
   IF LEN(Spec$) THEN
      WaveFile$ = Spec$
      repeats% = 1
   END IF
END IF

IF LEN(WaveFile$) = 0 THEN
END IF
CALL ValidWavHeader(WaveFile$, LenHeader%, WavLen&, Channels%, Sampling&, bytes&, ok%)
IF NOT ok% THEN
   PRINT "Bad Wave File Format"
   PRINT WaveFile$
   PRINT "Probably file not found. Check directory."
   PRINT "Or you need to program this word in. It can't be guessed."
END
END IF
MaxBuffer% = 7053
CALL WriteToDSP(&HD1)  'Speaker ON
FOR repeat% = 1 TO repeats%    'This can loop to play the file ii% times]
filenum% = FREEFILE
   OPEN WaveFile$ FOR BINARY AS filenum%
      num% = 0
      SEEK filenum%, LenHeader% + 1
      Remaining& = WavLen&
      DO
         num% = num% + 1
         IF Remaining& > MaxBuffer% THEN
            BufferLen% = MaxBuffer%
         ELSE
            BufferLen% = Remaining&
         END IF
         Remaining& = Remaining& - BufferLen%
         BUFFER$ = SPACE$(BufferLen%)
         GET filenum%, , BUFFER$
         CALL PlayBack(BUFFER$, BufferLen%, Sampling&, bytes&, Channels%, num%)
      LOOP WHILE Remaining& > 0
      OUT &H20, &H20   'Reset Normal Interrupt Service
   CLOSE filenum%
NEXT repeat%
CALL WriteToDSP(&HD3)  'Speaker OFF
'SLEEP
END SUB

SUB SAY (e$)
e$ = UCASE$(e$)
REMAIN$ = e$ + " EnDoFwAvEpHrAsE!"
DO UNTIL LTRIM$(RTRIM$(REMAIN$)) = "EnDoFwAvEpHrAsE!"
A = 0
  DO UNTIL t$ = " "
    A = A + 1
    t$ = MID$(REMAIN$, A, 1)
   LOOP
sayword LTRIM$(RTRIM$(LEFT$(REMAIN$, A)))
REMAIN$ = LTRIM$(RTRIM$(RIGHT$(REMAIN$, LEN(REMAIN$) - A + 1))): t$ = "": A = 0
sayword "[LONGPAUSE]"
LOOP
END SUB

SUB sayword (W$)
A = WordArray(UCASE$(W$))
IF A = -1 THEN GuessWord LCASE$(W$): EXIT SUB
FOR B = 1 TO LEN(Words(A).SND$)
S$ = MID$(Words(A).SND$, B, 1)
IF S$ = "" THEN END
IF S$ = " " THEN EXIT SUB
IF Capital(S$) THEN PlayWav "c" + S$ + ".wav" ELSE PlayWav S$ + ".wav"
NEXT B
END SUB

DEFINT A-Z
'------------------------------------------------------------------------------
FUNCTION SBreset%
'DSPreset% = address% + &H6
'DSPread% = address% + &HA
'DSPwrite% = address% + &HC
'DSPavail% = address% + &HE
'DSPmixer% = address% + &H4
OUT BlasterAddr% + &H6, 1   'Reset address
delay .1
OUT BlasterAddr% + &H6, 0
time1! = TIMER: noreset% = 0
DO
   'Read Data Available port until bit 7 is set
   'This should take about 100 micro seconds...give it 1 full second
   IF TIMER - time1! > 1! THEN noreset% = -1
LOOP UNTIL ((INP(BlasterAddr% + &HE) AND 128) = 128) OR noreset%
IF NOT noreset% THEN
   IF INP(BlasterAddr% + &HA) = &HAA THEN
      SBreset% = -1
   ELSE
      SBreset% = 0
   END IF
ELSE
   SBreset% = 0
END IF
END FUNCTION

'------------------------------------------------------------------------------
SUB ValidWavHeader (file$, LenHeader%, dataLen&, nChannels%, nSamplesPerSec&, nAvgBytesPerSec&, ok%)
rID$ = SPACE$(4)
wID$ = SPACE$(4)
fID$ = SPACE$(4)
dat$ = SPACE$(4)
dummy$ = SPACE$(1)
filenum% = FREEFILE
'
'
'
'File not found? Let me explain...
'
OPEN file$ FOR BINARY AS filenum%
'
'If you are using manual input (typing words directly into the pc),
'then you might have made a typo while entering words. entering a "[",
'or other non-letter character will cause the program to crash becasue
'it cannot find the file "[.wav". Get the idea? Or try to use different
'characters when saying a word. (Only the cahracters listed in the
'beginning of this file are allowed).
'
  GET filenum%, , rID$
  GET filenum%, , rLen&
  GET filenum%, , wID$
  GET filenum%, , fID$
  GET filenum%, , fLen&
  GET filenum%, , wFormatTag%       '2 bytes
  GET filenum%, , nChannels%        '2 bytes
  GET filenum%, , nSamplesPerSec&   '4 bytes
  GET filenum%, , nAvgBytesPerSec&  '4 bytes
  GET filenum%, , nBlockAlign%      '2 bytes
  GET filenum%, , FormatSpecific%   '2 bytes
  'Read bytes until have read fLen& total bytes.
  'I have no idea what these next bytes are used for (if they even exist).
  FOR I% = 1 TO fLen& - 16          '16 bytes is what we have read in so far
     GET filenum%, , dummy$         'read in 1 byte at a time
  NEXT I%
  GET filenum%, , dat$
  IF UCASE$(dat$) = "FACT" THEN
     'funny format...
     GET filenum%, , dummy&
     GET filenum%, , dummy&
     GET filenum%, , dat$
  END IF
  GET filenum%, , dataLen&
  LenHeader% = LOC(1)
CLOSE filenum%
'  CLS
'  PRINT rID$;
'  PRINT rLen&;
'  PRINT wID$;
'  PRINT fID$;
'  PRINT fLen&;
'  PRINT wFormatTag%;       '2 bytes
'  PRINT nChannels%;        '2 bytes
'  PRINT nSamplesPerSec&;   '4 bytes
'  PRINT nAvgBytesPerSec&;  '4 bytes
'  PRINT nBlockAlign%;      '2 bytes
'  PRINT FormatSpecific%;   '2 bytes
'  PRINT dat$;
'  PRINT dataLen&;
'  PRINT LenHeader%
IF UCASE$(rID$) = "RIFF" THEN
   IF UCASE$(wID$) = "WAVE" THEN
      IF UCASE$(dat$) = "DATA" THEN
         IF UCASE$(fID$) = "FMT " THEN
          IF FormatSpecific% = 8 THEN ok% = -1
         END IF
      END IF
   END IF
END IF
END SUB

DEFSNG A-Z
FUNCTION WordArray (WORD$)
Ba = 0
DO
Ba = Ba + 1
WW$ = Words(Ba).WORD$
IF LTRIM$(RTRIM$(WW$)) = LTRIM$(RTRIM$(WORD$)) OR LTRIM$(RTRIM$(WW$)) = "END OF LIST" THEN EXIT DO
LOOP
IF LTRIM$(RTRIM$(WW$)) = "END OF LIST" THEN WordArray = -1 ELSE WordArray = Ba
END FUNCTION

DEFINT A-Z
'------------------------------------------------------------------------------
SUB WriteToDSP (V%)
DO
LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, V%
END SUB

